!ifndef XPY_VERSION
  !define XPY_VERSION "1.1.4"
!endif

!ifndef VISPA_VERSION
  !define VISPA_VERSION "0.6.4"
!endif

!ifdef MINIXPY
  !ifndef LANGUAGE
    !define LANGUAGE "english"
  !endif
!endif

;Names and Numbers
!ifndef VISPA
  !define VERSION "${XPY_VERSION}"
  !define NAME "xpy ${VERSION}"
  !define SHORTNAME "xpy"
  !define LOWERCASE "${SHORTNAME}"
  !define WEBSITE "http://xpy.googlecode.com/"
!else
  !define VERSION "${VISPA_VERSION}"
  !define NAME "Vispa ${VERSION}"
  !define SHORTNAME "Vispa"
  !define LOWERCASE "vispa"
  !define WEBSITE "http://vispa.googlecode.com/"
!endif

;Header Compression
!ifdef COMPRESSION
  !if ${COMPRESSION} == "UPACK" ; Upack compression (http://wex.cn/dwing)
	!packhdr "$%TEMP%\exehead.tmp" "upack.exe $%TEMP%\exehead.tmp -c6 -f273" 
  !else if ${COMPRESSION} == "UPX" ; UPX compression (http://upx.sourceforge.net/)
	!packhdr "$%TEMP%\exehead.tmp" "upx.exe --best $%TEMP%\exehead.tmp"
  !else if ${COMPRESSION} == "PETITE" ; Petite compression (http://www.un4seen.com/petite/)
	!packhdr "$%TEMP%\exehead.tmp" "petite.exe -9 -r* -y $%TEMP%\exehead.tmp" 
  !endif
!endif

;Search Engine
; e.g. !define SEARCH "IXQUICK"
!ifdef SEARCH
  !if ${SEARCH} == "A9"
    !define SEARCHENGINE "A9 (a9.com)"
  !else if ${SEARCH} == "ALTAVISTA"
    !define SEARCHENGINE "Altavista (altavista.com)"
  !else if ${SEARCH} == "ASK"
    !define SEARCHENGINE "Ask (ask.com)"
  !else if ${SEARCH} == "BAIDU"
    !define SEARCHENGINE "Baidu (baidu.com)"
  !else if ${SEARCH} == "BING"
    !define SEARCHENGINE "Bing (bing.com)"
  !else if ${SEARCH} == "GOOGLE"
    !define SEARCHENGINE "Google (google.com)"
  !else if ${SEARCH} == "IXQUICK"
    !define SEARCHENGINE "Ixquick (ixquick.com)"
  !else if ${SEARCH} == "METACRAWLER"
    !define SEARCHENGINE "Metacrawler (metacrawler.com)"
  !else if ${SEARCH} == "WIKIA"
    !define SEARCHENGINE "Wikia (search.wikia.com)"
  !else if ${SEARCH} == "YAHOO"
    !define SEARCHENGINE "Yahoo! (yahoo.com)"
  !endif
!else
   !define SEARCHENGINE "Google (google.com)" ; default
!endif

;SpreadFirefox.com ID
!ifndef MOZID
  !define MOZID "118277"
!endif