; xpy/Vispa by Jan T. Sott
;   http://xpy.googlecode.com/
;   http://code.google.com/p/vispa/

;  Compiler Configuration (config.nsh)
;    public sourcecode does not require official branding
     !define PUBSRC
;    compiles Vispa (default is xpy)
     !define VISPA
;    compiles micro-version (of xpy)
#    !define MINIXPY ; uncomment for a stripped down version of xpy
;    configures header compression, possible options UPACK, UPX, PETITE (place executables in source root)
#    !define COMPRESSION "UPX"
;    configures default search engine for Internet Explorer, possible options:
;    A9, ASK, BAIDU, BING, GOOGLE (default), IXQUICK (special build default), METACRAWLER, YAHOO
#    !define SEARCH "IXQUICK"
;    configure included language (place language-file to /includes), comment line for multilingual builds
    !define LANGUAGE "english" ; uncomment for monolingual builds, use english language NAME of includes\lang_NAME.nsh

;   don't touch this line or file, it can be configured with the commands above
  !include "includes\config.nsh"

;  Variables
  Var Output
  Var Input
  Var OutfileName
  Var SaveFile
  Var RegFile
  !ifndef MINIXPY
    Var LoadFile
  !endif
  Var Passive
  Var Switches
  Var SearchEngineIni
  Var WinProduct
  Var WinVersion
  Var WinBuild
  Var User
  Var ComputerName
  Var Parameter
  #Var Help
  Var Caption
  #Var Message
  Var IeVersion
  Var IconRefresh
  Var Force
  !ifndef LANGUAGE
	Var ShowLang
  !endif
  Var ShowLicense
  Var NoReboot
  !ifndef VISPA
    Var Vista    
  !endif ;VISPA
  !ifndef MINIXPY
    Var emptyini
    Var Restore
    Var Warning
    Var MinSelect
  !endif ;MINIXPY
  Var GUID
  
!ifndef MINIXPY
;  UI Variables
  Var Dialog
  Var CheckBox
  Var GroupBox
  Var SearchLabel
  Var SearchEngine
  Var IELabel
  Var OutlookLabel
  Var MaxConnectionsLabel
  Var MaxConnections
  Var RDPLabel
  Var RDP
  Var preDialog
  Var ButtonMake
  Var ButtonRestore
  Var ButtonLoad
  Var ButtonSave
  Var ButtonReg
  Var LabelTop
  Var LabelBotton
  Var FileRequest
  Var ButtonBrowse
!endif ;MINIXPY
  Var IEShortcut
  Var OutlookShortcut
  
;  SearchEngines
  Var SearchPage
  Var SearchBar
  Var SearchQuery
  Var SearchName

;  Inclusions
  !ifndef MINIXPY
    !include "MUI2.nsh"
  !endif ;MINIXPY
  !include "WinMessages.nsh"
  !include "LogicLib.nsh"
  !include "WinVer.nsh"
  !include "x64.nsh"
  !include "nsDialogs.nsh"
  !include "FileFunc.nsh"
			!insertmacro GetParameters
			!insertmacro GetOptions
			!insertmacro GetFileName
			!insertmacro GetFileExt
  !ifndef MINIXPY
    !include "WordFunc.nsh"
             !insertmacro WordFind
  !endif ;MINIXPY
  !include "TextReplace.nsh"
  
;  Definitions
  !define SHCNE_ASSOCCHANGED 0x8000000
  !define SHCNF_IDLIST 0
  !define READONLY "17" ; 0.10: 17
  !define ALLSECTIONS "63" ; 0.10: 31
  !define ALLUNSECTIONS "4032"
  
  !define SelectSection "!insertmacro xpySelectSection"
  !define UnselectSection "!insertmacro xpyUnselectSection"
  !define RestoreSection "!insertmacro RestoreSection"
  !define IsINIEmpty "!insertmacro IsINIEmpty"
  !define LockSection "!insertmacro LockSection"
  !define LockUnSection "!insertmacro LockUnSection"

  !define Registry "!insertmacro Registry"
  !define RegStr "!insertmacro RegStr"
  !define RegExpStr "!insertmacro RegExpStr"
  !define UnRegDWORD "!insertmacro UnRegDWORD"
  !define UnRegStr "!insertmacro UnRegStr"
  !define UnRegExpStr "!insertmacro UnRegExpStr"
  !define Reload "!insertmacro Reload"
  !define ReloadOr "!insertmacro ReloadOr"
  !define DelWarn "!insertmacro DelWarning"
  
  !define mdTXT "!insertmacro MUI_DESCRIPTION_TEXT"
  
  !define REQUIRED "0xfff799"
  !define INVALID "0xffbfbf"
  !define VALID "0xd8eabd"
  !define NUMERIC "1234567890"

  !ifndef VISPA
    Name "${SHORTNAME}"
    Caption "${SHORTNAME}"
    OutFile "${LOWERCASE}.exe"
  !else ;VISPA
    Name "${SHORTNAME}"
    Caption "${SHORTNAME}"
    OutFile "${LOWERCASE}.exe"
  !endif ;VISPA
  SetDatablockOptimize on
  SetCompress force
  SetCompressor /SOLID lzma
  CRCCheck on
  XPStyle on
  RequestExecutionLevel admin ; for Vista or later
  InstallButtonText "$(LabelApply)"

  !ifndef PUBSRC
    BrandingText "whyEye.org"
    !ifndef MINIXPY
	  !define MUI_COMPONENTSPAGE_CHECKBITMAP "ui\yi-${LOWERCASE}.bmp"
      !define MUI_ICON "ui\yi-${LOWERCASE}.ico"
	  !ifndef VISPA
        !define MUI_UI "ui\${LOWERCASE}-ui.exe"
      !else ;VISPA
        !define MUI_UI "ui\${LOWERCASE}-ui_nodesc.exe"
      !endif ;VISPA
      !define MUI_LICENSEPAGE
      !define MUI_LICENSEPAGE_BGCOLOR "FFFFFF"
      !define MUI_INSTFILESPAGE_COLORS "000000 FFFFFF"
      !define MUI_INSTFILESPAGE_PROGRESSBAR "colored smooth"
	  !define MUI_BGCOLOR "0x1b1b1b"
    !else ;MINIXPY
      CheckBitmap "ui\yi-${LOWERCASE}.bmp"
      Icon "ui\yi-minixpy.ico"
      InstallColors 000000 FFFFFF
      InstProgressFlags colored smooth
    !endif ;MINIXPY
  !else ;PUBSRC
    BrandingText "${WEBSITE}"
  !endif ;PUBSRC

;  Installer Pages
  !ifndef MINIXPY
    !define MUI_CUSTOMFUNCTION_GUIINIT myGuiInit
	!define MUI_PAGE_CUSTOMFUNCTION_PRE LicenseShow
    !define MUI_PAGE_CUSTOMFUNCTION_LEAVE LicenseLeave
    !define MUI_LICENSEPAGE_TEXT_BOTTOM "$(LabelLicense)"
    !define MUI_LICENSEPAGE_CHECKBOX
      !insertmacro MUI_PAGE_LICENSE "license.txt"
	!define MUI_PAGE_HEADER_TEXT  "$(LabelSettings)"
    !define MUI_PAGE_HEADER_SUBTEXT  "$(LabelDescription)"
	Page custom ioPage ioPageLeave ;new  
    !define MUI_PAGE_CUSTOMFUNCTION_PRE ComponentsShow
    !define MUI_PAGE_CUSTOMFUNCTION_LEAVE ComponentsLeave    
      !insertmacro MUI_PAGE_COMPONENTS
    Page custom io2Page io2PageLeave ;new
    !define MUI_PAGE_CUSTOMFUNCTION_SHOW InstfilesShow
	!insertmacro MUI_PAGE_INSTFILES
  !else ;MINIXPY
    Page Components
    Page InstFiles
  !endif ;MINIXPY

  !include "includes\macros.nsh"

;Language Inclusions
  !ifndef LANGUAGE
    !include "includes\lang_english.nsh"
    !include "includes\lang_*.nsh"
  !else
    !include "includes\lang_${LANGUAGE}.nsh"
  !endif
  
;Version Information
  VIProductVersion "${VERSION}.0.0"
  VIAddVersionKey "ProductName" "${SHORTNAME}"
  VIAddVersionKey "FileVersion" "${VERSION}"
  VIAddVersionKey "LegalCopyright" "Jan T. Sott"
  !if ${SEARCH} == "IXQUICK"
    VIAddVersionKey "FileDescription" "${SHORTNAME} ${VERSION} (Ixquick Build)"
  !else ;IXQUICK
    VIAddVersionKey "FileDescription" "${SHORTNAME} ${VERSION} (Ixquick Build)"
  !endif ;IXQUICK
  VIAddVersionKey "Comments" "${WEBSITE}"


;InstallTypes
  !define Type3rdParty "2 3"
  !define TypeNo3rdParty "2 4"
  !define TypeClassic "2 4 5"
  !define TypeWin2003 "2 4 6"
  
  !ifndef MINIXPY
	  !define TypeUn3rdParty "8 9"
	  !define TypeUnNo3rdParty "8 10"
	  !define TypeUnClassic "8 10 11"
	  !define TypeUnWin2003 "8 10 12"
  !endif ;MINIXPY
  
  InstType "$(ITNone)"            ; 1 No Settings
  InstType "$(ITAll)"             ; 2 All Settings
  InstType "$(IT3rdParty)"        ; 3 3rd Party only
  InstType "$(ITNo3rdParty)"      ; 4 All Settings (no 3rd Party)
  InstType "$(ITClassic)"         ; 5 Windows Classic
  InstType "$(ITWin2k3)"          ; 6 Windows 2003 to Workstation
  !ifndef MINIXPY
	  InstType "$(ITNone)"       ; 7 Undo No Settings
	  InstType "$(ITAll)"        ; 8 Undo All Settings
	  InstType "$(IT3rdParty)"   ; 9 Undo 3rd Party only
	  InstType "$(ITNo3rdParty)" ;10 Undo All Settings (no 3rd Party)
	  InstType "$(ITClassic)"    ;11 Undo Windows Classic
	  InstType "$(ITWin2k3)"     ;12 Undo Windows 2003 to Workstation
  !endif ;MINIXPY
  !define AllSettings "1"
  !define No3rdPartySettings "3"
  
;Installer Sections
Section -pre
  IntCmp $Output "1" End 0 End  #val1 val2 jump_if_equal [jump_if_val1_less] [jump_if_val1_more]
  
  #StrCmp $Passive "1" 0 +2
  SetDetailsView show

!ifndef MINIXPY
  ${GetTime} "" "L" $R0 $R1 $R2 $R3 $R4 $R5 $R6
	; $0="01"      day
	; $1="04"      month
	; $2="2005"    year
	; $3="Friday"  day of week name
	; $4="11"      hour
	; $5="05"      minute
	; $6="50"      seconds
  
  ReadINIStr $0 "$APPDATA\${SHORTNAME}.ini" "${SHORTNAME}" "FirstRun"
  ${If} $0 == ""
	  WriteIniStr "$APPDATA\${SHORTNAME}.ini" "${SHORTNAME}" "FirstRun" "$R2-$R1-$R0@$R4:$R5.$R6"
  ${EndIf}
  
  WriteIniStr "$APPDATA\${SHORTNAME}.ini" "${SHORTNAME}" "LastRun" "$R2-$R1-$R0@$R4:$R5.$R6"
  
  ${If} $Passive == "1" ##review
	  ${IfNot} $Input == ""
	    ReadIniStr $CheckBox "$Input" "${SHORTNAME}" "RestorePoint"
	  ${EndIf}
  ${EndIf}
  
  StrCmp $CheckBox "1" 0 End
/*
  ReadRegDword $1 HKLM "SYSTEM\CurrentControlSet\Services\srservice" "Start"
  ${If} $1 == "4"
  ${OrIf} $1 == "3"
    MessageBox MB_YESNO "$(MBEnableRestore)" IDNO +4
    nsExec::Exec 'net.exe START "srservice"'
    DetailPrint "$(DPServStart)"
    StrCpy $RestoreTemp "1"
  ${EndIf}
*/
  DetailPrint "$(DPResPointCreate): ${NAME} $0"
  SysRestore::StartRestorePoint /NOUNLOAD "${NAME} $0"
  Pop $0
  ${IfNot} $0 == "0"
    IfSilent +4
    ${IfNot} $Passive == "1"
		MessageBox MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2 "$(MBResPointStartError)" IDYES +2
		Quit
	${EndIf}
    DetailPrint "$(DPResPointStartError): $0"
  ${EndIf}
!endif ;MINIXPY


!ifdef MINIXPY
  ${IfNot} $SearchEngineIni == ""
    StrCpy $SearchPage "http://google.com"
    StrCpy $SearchBar "http://google.com/ie"
    StrCpy $SearchQuery "http://www.google.com/search?q={searchTerms}"
    StrCpy $SearchName "Google"
    StrCpy $IEShortcut "$(LabelDelShortcut)"
    StrCpy $OutlookShortcut "$(LabelDelShortcut)"
  ${EndIf}
!endif ;MINIXPY
 End:
SectionEnd

!include "includes\sections_1_general.nsh"
!include "includes\sections_2_services.nsh"
!include "includes\sections_3_iexplorer.nsh"
!include "includes\sections_4_wmplayer.nsh"
!ifndef VISPA
  !include "includes\sections_5_wmessenger.nsh"
!endif ;VISPA
!include "includes\sections_6_winsearch.nsh"
!include "includes\sections_7_usability.nsh"
!include "includes\sections_8_delfiles.nsh"

Section -post
  !ifndef MINIXPY

    ${If} $Output < "1"
      ${If} $CheckBox == "1"
        SysRestore::FinishRestorePoint
        Pop $0
        StrCmp $0 0 +2
        DetailPrint "$(DPResPointEndError): $0"
/*
        ${If} $RestoreTemp == "1"
          nsExec::Exec 'net.exe STOP "srservice"'
          DetailPrint "$(DPServStop)"
        ${EndIf}
*/
      ${EndIf}
    ${ElseIf} $Output == "1"
		WriteINIStr "$SaveFile" "${SHORTNAME}" "RestorePoint" "$CheckBox"
	  	DetailPrint '"RestorePoint=1" $(DPWritten)'
	  	SectionGetFlags ${IESearchPage} $0
		SectionGetFlags ${IESearchScope} $1

		${If} $0 == "1"
		${OrIf} $1 == "1"
			  WriteIniStr "$SaveFile" "${SHORTNAME}" "Search" "$SearchEngine"
			  DetailPrint '"SearchEngine=$SearchEngine" $(DPWritten)'
		${EndIf}
        
    ${EndIf}

    StrCmp $Restore "1" 0 +2
    Call IsINIEmpty
  !endif ;MINIXPY
  IfFileExists "$APPDATA\${LOWERCASE}.ini" 0 +2
  SetFileAttributes "$APPDATA\${LOWERCASE}.ini" HIDDEN

  StrCmp $IconRefresh "1" 0 +2
  Call IconRefresh
  StrCmp $Passive "1" 0 +4
  DetailPrint "$(DPPasvExit)"
  Sleep 3000
  Quit

  ${If} $Output == "1"
    MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1 "$(MBSilentBatch)" IDYES +3
    WriteINIStr "$SaveFile" "${SHORTNAME}" "Review" "1"
    Goto +2
    DetailPrint "$(DPSilent)"
  ${ElseIf} $Output == "2"
	unicode::FileAnsi2Unicode "$RegFile" "$RegFile" UTF-16LE
  ${EndIf}
  
  ${If} $Output < "1"
    IfRebootFlag 0 +3
    MessageBox MB_YESNO|MB_ICONEXCLAMATION "$(MBReboot)" IDNO +2
    Reboot
  ${EndIf}
  
SectionEnd
 
;  Assign language strings to sections
  !ifndef MINIXPY
   !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    ${mdTXT} ${SecGeneral} $(DESC_SecGeneral)
    ${mdTXT} ${SecUnGeneral} $(DESC_SecGeneral)
      ${mdTXT} ${GenCompressedFolders} $(DESC_GenCompressedFolders)
      ${mdTXT} ${GenRegWizC} $(DESC_GenRegWizC)
      !ifndef VISPA
        ${mdTXT} ${GenErrorRep} $(DESC_GenErrorRep)
      !endif ;VISPA
      ${mdTXT} ${GenLMHash} $(DESC_GenLMHash)
      !ifndef VISPA
        ${mdTXT} ${GenWGA} $(DESC_GenWGA)
      !endif ;VISPA
      ${mdTXT} ${GenScriptHost} $(DESC_GenScriptHost)
      ${mdTXT} ${GenRemAssist} $(DESC_GenRemAssist)
      ${mdTXT} ${GenRestrictAnon} $(DESC_GenRestrictAnon)
      ${mdTXT} ${GenInetOpen} $(DESC_GenInetOpen)
      ${mdTXT} ${GenNetCrawl} $(DESC_GenNetCrawl)
      ${mdTXT} ${GenHideComputer} $(DESC_GenHideComputer)
      !ifndef VISPA
        ${mdTXT} ${GenRepInfect} $(DESC_GenRepInfect)
      !endif ;VISPA
      ${mdTXT} ${GenMediaSense} $(DESC_GenMediaSense)
      !ifndef VISPA
        ${mdTXT} ${GenClaimWinReg} $(DESC_GenClaimWinReg)
      !endif ;VISPA
      ${mdTXT} ${GenPrefetch} $(DESC_GenPrefetch)
      ${mdTXT} ${GenFastShutdn} $(DESC_GenFastShutdn)
      ${mdTXT} ${GenDelPagefile} $(DESC_GenDelPagefile)
      !ifndef VISPA
        ${mdTXT} ${GenDelMRU} $(DESC_GenDelMRU)
        ${mdTXT} ${GenRecentShares} $(DESC_GenRecentShares)
      !endif ;VISPA
      ${mdTXT} ${GenLastUser} $(DESC_GenLastUser)
      ${mdTXT} ${GenPriorityCtrl} $(DESC_GenPriorityCtrl)
      !ifdef VISPA
        #${mdTXT} ${GenSysResponse} $(DESC_GenSysResponse)
        #${mdTXT} ${GenDisableUAC} $(DESC_GenDisableUAC)
      !endif ;VISPA
      ${mdTXT} ${GenRDPPort} $(DESC_GenRDPPort)
	  !ifndef VISPA
		${mdTXT} ${GenSpyNet} $(DESC_GenSpyNet)
	  !endif
    ${mdTXT} ${SecServices} $(DESC_SecServices)
    ${mdTXT} ${SecUnServices} $(DESC_SecServices)
      ${mdTXT} ${ServErrorRep} $(DESC_ServErrorRep)
      ${mdTXT} ${ServAutoWinUpd} $(DESC_ServAutoWinUpd)
      ${mdTXT} ${ServSecCenter} $(DESC_ServSecCenter)
      ${mdTXT} ${ServWinDefend} $(DESC_ServWinDefend)
      ${mdTXT} ${ServTimeSync} $(DESC_ServTimeSync)
      ${mdTXT} ${ServSchedTask} $(DESC_ServSchedTask)
      !ifndef VISPA
        ${mdTXT} ${ServIndexing} $(DESC_ServIndexing)
        ${mdTXT} ${ServDCOM} $(DESC_ServDCOM)
        ${mdTXT} ${ServTelnet} $(DESC_ServTelnet)
        ${mdTXT} ${ServUPnP} $(DESC_ServUPnP)
        ${mdTXT} ${ServUPnPDiscovery} $(DESC_ServUPnPDiscovery)
        ${mdTXT} ${ServMessenger} $(DESC_ServMessenger)
        ${mdTXT} ${ServNetMeetingDesktop} $(DESC_ServNetMeetingDesktop)
      !endif ;VISPA
      ${mdTXT} ${ServRPCLoc} $(DESC_ServRPCLoc)
      ${mdTXT} ${ServRemReg} $(DESC_ServRemReg)
      !ifndef VISPA
        ${mdTXT} ${ServIcfIcs} $(DESC_ServIcfIcs)
	  !endif ;VISPA
	  ${mdTXT} ${ServImapi} $(DESC_ServImapi)
	  ${mdTXT} ${ServAudioSrv} $(DESC_ServAudioSrv)
	  ${mdTXT} ${ServWIA} $(DESC_ServWIA)
      ${mdTXT} ${TPAppleMobile} $(DESC_TPAppleMobile)
      ${mdTXT} ${TPIpodService} $(DESC_TPIpodService)
      ${mdTXT} ${TPGoogleUpdater} $(DESC_TPGoogleUpdater)
      ${mdTXT} ${TPGoogleSAC} $(DESC_TPGoogleSAC)
            
    ${mdTXT} ${SecIExplore} $(DESC_SecIExplore)
    ${mdTXT} ${SecUnIExplore} $(DESC_SecIExplore)
      ${mdTXT} ${IEAutoUpdates} $(DESC_IEAutoUpdates)
      ${mdTXT} ${IESchedUpd} $(DESC_IESchedUpd)
      ${mdTXT} ${IEErrorRep} $(DESC_IEErrorRep)
      ${mdTXT} ${IEIntWinAuth} $(DESC_IEIntWinAuth)
      ${mdTXT} ${IEMaxConn} $(DESC_IEMaxConn)
      ${mdTXT} ${IETabSettings} $(DESC_IETabSettings)
      ${mdTXT} ${IEuplddrvinfo} $(DESC_IEuplddrvinfo)
      ${mdTXT} ${IEDelTempFiles} $(DESC_IEDelTempFiles)
      ${mdTXT} ${IEWebformComplete} $(DESC_IEWebformComplete)
      ${mdTXT} ${IEPasswordComplete} $(DESC_IEPasswordComplete)
      ${mdTXT} ${IEAlexa} $(DESC_IEAlexa)
      ${mdTXT} ${IESearchPage} $(DESC_IESearchPage)
      ${mdTXT} ${IESearchScope} $(DESC_IESearchScope)
      ${mdTXT} ${IEActiveX} $(DESC_IEActiveX)
      ${mdTXT} ${IEJavaScript} $(DESC_IEJavaScript)
      ${mdTXT} ${IESSL2} $(DESC_IESSL2)
      ${mdTXT} ${IEPhishFilter} $(DESC_IEPhishFilter)
      ${mdTXT} ${IESearchAsst} $(DESC_IESearchAsst)
      ${mdTXT} ${IE404Search} $(DESC_IE404Search)
      ${mdTXT} ${IEBlankPage} $(DESC_IEBlankPage)
      ${mdTXT} ${IEDefaultPrompt} $(DESC_IEDefaultPrompt)
      ${mdTXT} ${IEInfoBar} $(DESC_IEInfoBar)
      ${mdTXT} ${IERemove} $(DESC_IERemove)
    ${mdTXT} ${SecWMP} $(DESC_SecWMP)
    ${mdTXT} ${SecUnWMP} $(DESC_SecWMP)
      ${mdTXT} ${WMPAutoLicAcqu} $(DESC_WMPAutoLicAcqu)
      !ifdef VISPA
        #${mdTXT} ${WMPSilentDRM} $(DESC_WMPSilentDRM)
      !endif ;VISPA
      !ifndef VISPA
        ${mdTXT} ${WMPUpgradeMsg} $(DESC_WMPUpgradeMsg)
      !endif ;VISPA
      ${mdTXT} ${WMPLibrary} $(DESC_WMPLibrary)
      ${mdTXT} ${WMPMetadataRet} $(DESC_WMPMetadataRet)
      ${mdTXT} ${WMPUsageTrack} $(DESC_WMPUsageTrack)
      !ifdef VISPA
        #${mdTXT} ${WMPSendUID} $(DESC_WMPSendUID)
      !endif ;VISPA
      !ifndef VISPA
        ${mdTXT} ${WMPAutoUpdates} $(DESC_WMPAutoUpdates)
        ${mdTXT} ${WMPNoMRU} $(DESC_WMPNoMRU)
      !endif ;VISPA
      ${mdTXT} ${WMPAutoCodecDownl} $(DESC_WMPAutoCodecDownl)
      ${mdTXT} ${WMPImportMP3} $(DESC_WMPImportMP3)
      ${mdTXT} ${WMPNoDRM} $(DESC_WMPNoDRM)
    !ifndef VISPA
        ${mdTXT} ${WMPAllowDeinst} $(DESC_WMPAllowDeinst)
      ${mdTXT} ${SecWinMessenger} $(DESC_SecWinMessenger)
      ${mdTXT} ${SecUnWinMessenger} $(DESC_SecWinMessenger)
        ${mdTXT} ${WMRemOE} $(DESC_WMRemOE)
        ${mdTXT} ${WMUninstall} $(DESC_WMUninstall)
    !endif ;VISPA
    ${mdTXT} ${SecWinSearch} $(DESC_SecWinSearch)
    ${mdTXT} ${SecUnWinSearch} $(DESC_SecWinSearch)
      ${mdTXT} ${WDSDisable} $(DESC_WDSDisable)
      ${mdTXT} ${WDSRemove} $(DESC_WDSRemove)
   ${mdTXT} ${SecUsability} $(DESC_SecUsability)
   ${mdTXT} ${SecUnUsability} $(DESC_SecUsability)
      !ifndef VISPA
        ${mdTXT} ${UsabBalloonTips} $(DESC_UsabBalloonTips)
      !endif ;VISPA
      ${mdTXT} ${UsabDiskSpace} $(DESC_UsabDiskSpace)
      !ifndef VISPA
        ${mdTXT} ${UsabCmdHere} $(DESC_UsabCmdHere)
        ${mdTXT} ${UsabCmdCompl} $(DESC_UsabCmdCompl)
      !endif ;VISPA
      ${mdTXT} ${UsabEditNotepad} $(DESC_UsabEditNotepad)
      ${mdTXT} ${UsabAutoRun} $(DESC_UsabAutoRun)
      !ifndef VISPA
        ${mdTXT} ${UsabSearchAsst} $(DESC_UsabSearchAsst)
      !endif ;VISPA
      ${mdTXT} ${UsabCleanupWiz} $(DESC_UsabCleanupWiz)
      ${mdTXT} ${UsabTaskGroup} $(DESC_UsabTaskGroup)
      ${mdTXT} ${UsabClassicStartMenu} $(DESC_UsabClassicStartMenu)
      ${mdTXT} ${UsabClassicLogon} $(DESC_UsabClassicLogon)
	  ${mdTXT} ${UsabShutdownReason} $(DESC_UsabShutdownReason)
      !ifndef VISPA
        ${mdTXT} ${UsabBarricade} $(DESC_UsabBarricade)
      !endif ;VISPA
      ${mdTXT} ${UsabHiddenFiles} $(DESC_UsabHiddenFiles)
      ${mdTXT} ${UsabShowFileExt} $(DESC_UsabShowFileExt)
      ${mdTXT} ${UsabShowLNKExt} $(DESC_UsabShowLNKExt)
      ${mdTXT} ${UsabShowPIFExt} $(DESC_UsabShowPIFExt)
      ${mdTXT} ${UsabShowSCFExt} $(DESC_UsabShowSCFExt)
      ${mdTXT} ${UsabShowURLExt} $(DESC_UsabShowURLExt)
      ${mdTXT} ${UsabFullPath} $(DESC_UsabFullPath)
      ${mdTXT} ${UsabDisableThumbnails} $(DESC_UsabDisableThumbnails)
      ${mdTXT} ${UsabDisableSounds} $(DESC_UsabDisableSounds)
      ${mdTXT} ${UsabWinTheme} $(DESC_UsabWinTheme)

      ${mdTXT} ${SecDelete} $(DESC_SecDelete)
      ${mdTXT} ${SecUnDelete} $(DESC_SecDelete)
      ${mdTXT} ${DelIELnk} $(DESC_DelIELnk)
	  !ifndef VISPA
        ${mdTXT} ${DelOutExLnk} $(DESC_DelOutExLnk)
	  !endif ;VISPA
      ${mdTXT} ${DelRecycleBinLnk} $(DESC_DelRecycleBinLnk)
      ${mdTXT} ${DelMyDocumentsLnk} $(DESC_DelMyDocumentsLnk)
      ${mdTXT} ${DelMyComputerLnk} $(DESC_DelMyComputerLnk)
	  ${mdTXT} ${DelMyNetworkLnk} $(DESC_DelMyNetworkLnk)
	  !ifdef VISPA
	    ${mdTXT} ${DelControlPanelLnk} $(DESC_DelControlPanelLnk)
	  !endif ;VISPA
      ${mdTXT} ${DelWMPLnk} $(DESC_DelWMPLnk)
      ${mdTXT} ${DelMovieMkLnk} $(DESC_DelMovieMkLnk)
      ${mdTXT} ${DelMSNLnk} $(DESC_DelMSNLnk)
      !ifndef VISPA
        ${mdTXT} ${DelMessengerLnk} $(DESC_DelMessengerLnk)
      !endif ;VISPA
      ${mdTXT} ${DelWinUpdate} $(DESC_DelWinUpdate)
      !ifndef VISPA
        ${mdTXT} ${DelWinCatalog} $(DESC_DelWinCatalog)
        ${mdTXT} ${DelProgAccess} $(DESC_DelProgAccess)
      !endif ;VISPA
      ${mdTXT} ${DelMsBookmarks} $(DESC_DelMsBookmarks)
      ${mdTXT} ${DelSamplePictures} $(DESC_DelSamplePictures)
      ${mdTXT} ${DelSampleMusic} $(DESC_DelSampleMusic)
      ${mdTXT} ${DelSamplePlaylists} $(DESC_DelSamplePlaylists)
      ${mdTXT} ${DelBitmaps} $(DESC_DelBitmaps)
      ${mdTXT} ${DelPrefetch} $(DESC_DelPrefetch)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END
 !endif ;MINIXPY

 ;Installer Functions
 Function .onInit
!ifndef MINIXPY
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "${SHORTNAME}") i .r1 ?e'
  Pop $R0
  StrCmp $R0 0 +3
  MessageBox MB_YESNO|MB_DEFBUTTON2|MB_ICONQUESTION "$(MBInstance)" IDYES +2
  Abort
!endif ;MINIXPY

  ${If} ${RunningX64}
	SetRegView 64
  ${Else}
	SetRegView 32
  ${EndIf}
 
  ClearErrors
  ReadRegStr $WinVersion HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "CurrentVersion"

 #ParameterCheck:
  ReadRegStr $WinProduct HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "ProductName"
  ReadRegStr $WinBuild HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "CurrentBuildNumber"
  ReadRegStr $User HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer" "Logon User Name"
  ${If} $User == ""
	ReadRegStr $User HKCU "Volatile Environment" "USERNAME"
  ${EndIf}
  ReadRegStr $ComputerName HKLM "SYSTEM\ControlSet001\Control\ComputerName\ComputerName" "ComputerName"

!ifndef MINIXPY
  InitPluginsDir
  SetOutPath $PLUGINSDIR
!endif ;MINIXPY

  ${GetParameters} $Parameter
  
  ${If} $Parameter == "/?"
  ${OrIf} $Parameter == "-?"
  ${OrIf} $Parameter == "/help"
  ${OrIf} $Parameter == "/h"
  ${OrIf} $Parameter == "-h"
  ${OrIf} $Parameter == "--help"
  ${OrIf} $Parameter == "--h"
  ${OrIf} $Parameter == "--?"
  ${OrIf} $Parameter == "help"
	StrCpy $Switches "$Switches$\r$\n/help$\t$\t$(LabelShowHelp)"
	StrCpy $Switches "$Switches$\r$\n/file$\t$\t$(LabelSaveSettings)"
	StrCpy $Switches "$Switches$\r$\n/reg$\t$\t$(LabelRegSettings)"
	!ifndef MINIXPY
		StrCpy $Switches "$Switches$\r$\n/flush$\t$\t$(LabelDeleteIni)"
		StrCpy $Switches "$Switches$\r$\n/force$\t$\t$(LabelForce)"
		!ifndef LANGUAGE
			StrCpy $Switches "$Switches$\r$\n/lang$\t$\t$(LabelLangMenu)"
		!endif
		StrCpy $Switches "$Switches$\r$\n/license$\t$\t$(LabelShowLicense)"
	!endif
	StrCpy $Switches "$Switches$\r$\n/all$\t$\t$(LabelApplyAll)"
	!ifndef MINIXPY
		StrCpy $Switches "$Switches$\r$\n/restore$\t$\t$(LabelRestore)"
		StrCpy $Switches "$Switches$\r$\n/restore-all$\t$(LabelRestoreAll)"
		StrCpy $Switches "$Switches$\r$\n/noreboot$\tt$(LabelNoReboot)"
		StrCpy $Switches "$Switches$\r$\n/shortcuts$\t$(LabelCreateShortcut)"
		StrCpy $Switches "$Switches$\r$\n/install$\t$\t$(LabelAssociate)"
		StrCpy $Switches "$Switches$\r$\n/uninstall$\t$\t$(LabelUnAssociate)"
		StrCpy $Switches "$Switches$\r$\n/win$\t$\t$(LabelWinVersion)"
	!endif
	
      MessageBox MB_ICONINFORMATION|MB_DEFBUTTON1 "${NAME} $(LabelSwitches):$\r$\n$Switches"
	  Quit
  ${EndIf}
  
    !ifndef MINIXPY
	  !ifndef LANGUAGE
	    ${GetOptions} $Parameter "/lang=" $0
		${If} $0 == 1
			StrCpy $ShowLang 1
			Call LangSelect
		${ElseIf} $Parameter == "/lang"			
			Call LangSelect
			Goto NoRestore
		${EndIf}
	  !endif ;LANGUAGE
	!endif ;MINIXPY
  
  !ifdef VISPA
    ${IfNot} $Parameter == "/debug"
	${AndIfNot} $Parameter == "/win"
	    StrCpy $0 $WinVersion 1
	    StrCmp $0 "6" +3 0
	    MessageBox MB_OK|MB_ICONSTOP "$(MBVistaWarning)"
	    Quit
	${EndIf}
  !else ;VISPA	
	${IfNot} $Parameter == "/debug"
	${AndIfNot} $Parameter == "/win"
		${If} ${IsWinVista}
			MessageBox MB_OK|MB_ICONEXCLAMATION "$(MBFeatureLimited)"
			StrCpy $Vista "1"
		${ElseIfNot} ${AtLeastWin2000} #ignorethis?
		${OrIfNot} ${AtMostWinVista}
			ReadINIStr $0 "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "IgnoreOSWarning"
			${If} $0 != "1"
				MessageBox MB_YESNO|MB_DEFBUTTON2|MB_ICONSTOP  "$(MBWrongWin)" IDNO +3
				WriteINIStr "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "IgnoreOSWarning" "1"
				Goto +2
				Quit
			${EndIf}
		${EndIf}  
	${EndIf}
  !endif ;VISPA
  
    StrCmp $Parameter "" End
  
  ${If} $Parameter == "/win"
	  MessageBox MB_OK|MB_ICONINFORMATION "$WinProduct [Version $WinVersion.$WinBuild]$\n$\n$(MBLoggedAs) $ComputerName\$User"
	  Quit
  ${ElseIf} $Parameter == "/debug"
	  StrCpy $Caption "[/debug]"
	  Goto NoRestore
  ${ElseIf} $Parameter == "/force"
	  StrCpy $Force "1"
	  Goto End
   ${ElseIf} $Parameter == "/file" 
	  StrCpy $Output "1"
	  StrCpy $SaveFile "$DESKTOP\$User.$ComputerName.${LOWERCASE}"
	  FileInput:
	  IfFileExists "$SaveFile" 0 NoRestore
	  MessageBox MB_YESNO|MB_ICONQUESTION "$(MBOverwrite)" IDNo NoRestore
	  Delete "$SaveFile"
	  Goto NoRestore
   ${ElseIf} $Parameter == "/reg" 
	  StrCpy $Output "2"
	  StrCpy $RegFile "$DESKTOP\$User.$ComputerName.reg"
	  RegInput:
	  IfFileExists "$RegFile" 0 NoRestore
	  MessageBox MB_YESNO|MB_ICONQUESTION "$(MBOverwrite)" IDNo NoRestore
	  Delete "$RegFile"
	  Goto NoRestore
  !ifndef MINIXPY
  ${ElseIf} $Parameter == "/license"
      StrCpy $Caption "[/license]"
	  StrCpy $ShowLicense 1
	  Goto NoRestore
  ${ElseIf} $Parameter == "/noreboot"
	  StrCpy $NoReboot 1
	  Goto NoRestore
  ${ElseIf} $Parameter == "/install"
  ${OrIf} $Parameter == "/inst"
	  WriteRegStr HKCR ".${LOWERCASE}" "" "${LOWERCASE}.Settings"
	  WriteRegStr HKCR "${LOWERCASE}.Settings" "" "${SHORTNAME} Settings"
	  WriteRegStr HKCR "${LOWERCASE}.Settings\DefaultIcon" "" "%SystemRoot%\System32\shell32.dll,-151"
	  WriteRegStr HKCR "${LOWERCASE}.Settings\shell" "" "open"
	  WriteRegStr HKCR "${LOWERCASE}.Settings\shell\open\command" "" '"$EXEDIR\${LOWERCASE}.exe" "%1"'
	  Call IconRefresh
	  Quit
  ${ElseIf} $Parameter == "/uninstall"
  ${OrIf} $Parameter == "/uninst"
	  DeleteRegKey HKCR ".${LOWERCASE}"
	  DeleteRegKey HKCR "${LOWERCASE}.Settings"
	  Call IconRefresh
	  Quit
  ${ElseIf} $Parameter == "/shortcuts"
  ${OrIf} $Parameter == "/cuts"
	  IfFileExists "$EXEDIR\$(LabelAdvanced)\*.*" +2
	  CreateDirectory "$EXEDIR\$(LabelAdvanced)"
	  CreateShortCut "$EXEDIR\$(LabelAdvanced)\$(LabelAssociateSc).lnk" "$EXEDIR\xpy.exe" "/install"
	  CreateShortCut "$EXEDIR\$(LabelAdvanced)\$(LabelCreateProfileSc).lnk" "$EXEDIR\xpy.exe" "/file"
	  CreateShortCut "$EXEDIR\$(LabelAdvanced)\$(LabelRestoreSettingsSc).lnk" "$EXEDIR\xpy.exe" "/restore"
	  CreateShortCut "$EXEDIR\$(LabelAdvanced)\$(LabelUnassociateSc).lnk" "$EXEDIR\xpy.exe" "/uninstall"
	  ExecShell open "$EXEDIR\$(LabelAdvanced)"
	  Quit  
  ${ElseIf} $Parameter == "/flush"
	  IfFileExists "$APPDATA\${LOWERCASE}.ini" 0 +3
	  MessageBox MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2 "$(MBDeleteIniWarning)" IDNO +2
	  Delete /REBOOTOK "$APPDATA\${LOWERCASE}.ini"
	  Quit
  !endif ;MINIXPY
  ${ElseIf} $Parameter == "/restore-all"
  ${OrIf} $Parameter == "/res-all"
	  !ifndef MINIXPY
	    Call UnSelectUnSections
	  !endif ;MINIXPY
	  Call SelectSections
	  SetSilent silent
	  Goto End
	  !ifndef MINIXPY
  ${ElseIf} $Parameter == "/restore"
  ${OrIf} $Parameter == "/res"
	  Call Restore
	  Goto End  
!endif ;MINIXPY
  ${EndIf} 
  
  #save profile or to reg file
  ${GetOptions} "$Parameter" "/file=" $SaveFile
  ${GetOptions} "$Parameter" "/reg=" $RegFile
  
  ${If} $SaveFile != ""
  ${AndIf} $RegFile == ""
	  ${GetFileExt} $SaveFile $0
	  StrCmp $0 "${LOWERCASE}" +2
	  StrCpy $SaveFile "$SaveFile.${LOWERCASE}"
	  
	  ${GetParent} $SaveFile $0
	  StrCmp $0 "" 0 +2
	  StrCpy $SaveFile "$DESKTOP\$SaveFile"

	  StrCpy $Output "1"
	  Goto FileInput
  ${EndIf}
  
  ${If} $RegFile != ""
  ${AndIf} $SaveFile == ""
	  ${GetFileExt} $RegFile $0
	  StrCmp $0 "reg" +2
	  StrCpy $RegFile "$RegFile.reg"
	  
	  ${GetParent} $RegFile $0
	  StrCmp $0 "" 0 +2
	  StrCpy $RegFile "$DESKTOP\$RegFile"
	  
	  StrCpy $Output "2"
	  Goto RegInput
  ${EndIf}
    
  #/force=1
  ${GetOptions} "$Parameter" "/force=" $0
  StrCmp $0 "1" 0 +2
  StrCpy $Force 1
  
  #/license=1
  ${GetOptions} "$Parameter" "/license=" $0
  StrCmp $0 "1" 0 +2
  StrCpy $ShowLicense 1
  
  #/noreboot=1
  ${GetOptions} "$Parameter" "/noreboot=" $0
  StrCmp $0 "1" 0 +2
  StrCpy $NoReboot 1

  StrCmp $ShowLicense 1 NoRestore  
  StrCmp $Force 1 NoRestore 
  !ifndef LANGUAGE
	StrCmp $ShowLang 1 NoRestore  
  !endif
  StrCmp $NoReboot 1 NoRestore  
  
  StrCpy $Input $Parameter
  Call ValidateInput
  Goto End
   
 NoRestore:
  InstTypeSetText 6 ""
  InstTypeSetText 7 ""
  InstTypeSetText 8 ""
  InstTypeSetText 9 ""
  InstTypeSetText 10 ""
  InstTypeSetText 11 ""
  InstTypeSetText 12 ""
  !ifndef MINIXPY
    Call UnSelectUnSections
    Call AutoDetect
  !endif ;MINIXPY

  End:
 FunctionEnd

 
!ifndef MINIXPY
Function myGUIInit
	GetDlgItem $0 $HWNDPARENT 1037 #Caption
	SetCtlColors $0 0xFFFFFF 0x1b1b1b
	GetDlgItem $0 $HWNDPARENT 1038 #Subcaption
	SetCtlColors $0 0xFFFFFF 0x1b1b1b
FunctionEnd

 Function unComponentsShow
; -locks WDSUnDisable if Windows Desktop Search was removed
; -locks unsectiongroups with all content locked
 
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\KB940157" "UninstallString"
  ${If} $0 == ""
  ${AndIfNot} $Force == "1"
	  IntOp $1 ${SF_SELECTED} | ${SF_RO}
	  SectionSetFlags ${WDSUnDisable} $1
	  SectionSetInstTypes ${WDSUnDisable} ${ALLUNSECTIONS}
  ${EndIf}
       
  ${LockUnSection} ${SecUnGeneral} ${SecServices}
  ${LockUnSection} ${SecUnServices} ${SecIExplore}
  ${LockUnSection} ${SecUnIExplore} ${SecWMP}
  !ifndef VISPA
    ${LockUnSection} ${SecUnWMP} ${SecWinMessenger}
    ${LockUnSection} ${SecUnWinMessenger} ${SecWinSearch}
    ${LockUnSection} ${SecUnWinSearch} ${SecUsability}
    ${LockUnSection} ${SecUnUsability} ${SecDelete}
    IntOp $0 ${DelUnWinUpdate} + 2
    ${LockUnSection} ${SecUnDelete} $0
  !else ;VISPA
    ${LockUnSection} ${SecUnWMP} ${SecWinSearch}
    ${LockUnSection} ${SecUnWinSearch} ${SecUsability}
    ${LockUnSection} ${SecUnUsability} ${SecDelete}
    IntOp $0 ${DelUnWinMeetSpace} + 2
    ${LockUnSection} ${SecUnDelete} $0
  !endif ;VISPA
 FunctionEnd

 Function ComponentsShow
; -changes caption if parameter was used
; -disables back button
; -locks sectiongroups with all content locked
; -checks if all sections are locked and displays warning
  SendMessage $HWNDPARENT ${WM_SETTEXT} 0 `STR:${SHORTNAME} $Caption`
  
  GetDlgItem $0 $HWNDPARENT 3
  EnableWindow $0 0
  
  ${LockSection} ${SecGeneral} ${SecUnGeneral}
  ${LockSection} ${SecServices} ${SecUnServices}
  ${LockSection} ${SecIExplore} ${SecUnIExplore}
  ${LockSection} ${SecWMP} ${SecUnWMP}
  !ifndef VISPA
    ${LockSection} ${SecWinMessenger} ${SecUnWinMessenger}
  !endif ;VISPA
  ${LockSection} ${SecWinSearch} ${SecUnWinSearch}
  ${LockSection} ${SecUsability} ${SecUnUsability}
  ${LockSection} ${SecDelete} ${SecUnDelete}

  SectionGetFlags ${SecGeneral} $0
  StrCmp $0 "${READONLY}" 0 Possible
  SectionGetFlags ${SecServices} $0
  StrCmp $0 "${READONLY}" 0 Possible
  SectionGetFlags ${SecIExplore} $0
  StrCmp $0 "${READONLY}" 0 Possible
  SectionGetFlags ${SecWMP} $0
  StrCmp $0 "${READONLY}" 0 Possible
  !ifndef VISPA
    SectionGetFlags ${SecWinMessenger} $0
    StrCmp $0 "${READONLY}" 0 Possible
  !endif ;VISPA
  SectionGetFlags ${SecWinSearch} $0
  StrCmp $0 "${READONLY}" 0 Possible
  SectionGetFlags ${SecUsability} $0
  StrCmp $0 "${READONLY}" 0 Possible
  SectionGetFlags ${SecDelete} $0
  StrCmp $0 "${READONLY}" 0 Possible
  MessageBox MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2 "$(MBImpossible)" IDYES +2
  Quit

  Possible:
  StrCmp $Passive "1" 0 +2
  Abort
 FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
 Function ComponentsLeave
;   -checks if any section is selected and displays warning
;   -checks if all sections are selected and displays warning
;   -checks if irretrievable sections are selected and displays warning
   Push $0
   SectionGetFlags ${WDSRemove} $0
   ${If} $0 == ${SF_SELECTED}
     SectionGetFlags "${WDSDisable}" $0
     Push $1
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags "${WDSDisable}" $1
     Pop $1
   ${EndIf}
   Pop $0
   
    StrCpy $MinSelect "0"
    StrCpy $Warning ""
    
   !insertmacro MinSelect ${SecGeneral} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecGeneral} ${SF_SELECTED}
   !insertmacro MinSelect ${SecServices} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecServices} ${SF_SELECTED}
   !insertmacro MinSelect ${SecIExplore} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecIExplore} ${SF_SELECTED}
   !insertmacro MinSelect ${SecWMP} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecWMP} ${SF_SELECTED}
   !ifndef VISPA
     !insertmacro MinSelect ${SecWinMessenger} ${SF_PSELECTED}
     !insertmacro MinSelect ${SecWinMessenger} ${SF_SELECTED}
   !endif ;VISPA
   !insertmacro MinSelect ${SecWinSearch} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecWinSearch} ${SF_SELECTED}
   !insertmacro MinSelect ${SecUsability} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecUsability} ${SF_SELECTED}
   !insertmacro MinSelect ${SecDelete} ${SF_PSELECTED}
   !insertmacro MinSelect ${SecDelete} ${SF_SELECTED}
   
   GetCurInstType $0
   StrCmp $0 "0" 0 +4
   MessageBox MB_OK|MB_ICONQUESTION "$(MBNoSettings)"
   Abort
   
   GetCurInstType $0
   ${If} $0 == "${AllSettings}"
   ${OrIf} $0 == "${No3rdPartySettings}"
     MessageBox MB_YESNO|MB_ICONQUESTION "$(MBAllSettings)" IDYES +2
     Abort
   ${EndIf}
   
   StrCmp $MinSelect "0" NoSetting
   /*
   StrCmp $Output "1" 0 +3
   WriteINIStr "$SaveFile" "${LOWERCASE}" "Version" "${VERSION}"
   Goto +2
   WriteINIStr "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "Version" "${VERSION}"
   */
   /*
   ${If} $Output == "1"
		WriteINIStr "$SaveFile" "${LOWERCASE}" "Version" "${VERSION}"
   ${ElseIf} $Output == "2"
		FileOpen $0 "$RegFile" w
		FileWrite $0 "Windows Registry Editor Version 5.00"
		FileClose $0
   ${Else}
		WriteINIStr "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "Version" "${VERSION}"
   ${EndIf}
   */

  NoSetting:
  !ifndef VISPA
    ${DelWarn} ${GenWGA} "$(SecGenWGA)"
  !endif ;VISPA
   ${DelWarn} ${IEAlexa} "$(SecIEAlexa)"
   ${DelWarn} ${IERemove} "$(SecIERemove)"
   !ifndef VISPA
     ${DelWarn} ${WMUninstall} "$(SecWMUninstall)"
   !endif ;VISPA
   #${DelWarn} ${WDSRemove} "$(SecWDSRemove)"
   ${IfNot} ${FileExists} "$PROGRAMFILES\Movie Maker\moviemk.exe"
     ${DelWarn} ${DelMovieMkLnk} "$(SecDelMovieMkLnk)"
   ${EndIf}

!ifdef VISPA
/*
   !insertmacro SectionFlagIsSet ${DelWinDVDMk} ${SF_RO} PostDelWinDVDMkLnk NextDelWinDVDMkLnk
   NextDelWinDVDMkLnk:
   !insertmacro SectionFlagIsSet ${DelWinDVDMk} ${SF_SELECTED} DelWinDVDMkLnkWarning PostDelWinDVDMkLnk
   DelWinDVDMkLnkWarning:
   StrCpy $Warning "$Warning$\n- $(SecDelWinDVDMk)"
   PostDelWinDVDMkLnk:
*/
   ${IfNot} ${FileExists} "$PROGRAMFILES\Windows Photo Gallery\WindowsPhotoGallery.exe"
     ${DelWarn} ${DelWinPhotoGal} "$(SecDelWinPhotoGal)"
   ${EndIf}

   ${IfNot} ${FileExists} "$PROGRAMFILES\Windows Defender\MsAsCui.exe"
     ${DelWarn} ${DelWinDefender} "$(SecDelWinDefender)"
   ${EndIf}

   ${DelWarn} ${DelWinLiveDl} "$(SecDelWinLiveDl)"

   ${IfNot} ${FileExists} "$SYSDIR\WFS.exe"
     ${DelWarn} ${DelWinFaxScan} "$(SecDelWinFaxScan)"
   ${EndIf}

   ${IfNot} ${FileExists} "$PROGRAMFILES\Windows Calendar\wincal.exe"
      ${DelWarn} ${DelWinCalendar} "$(SecDelWinCalendar)"
   ${EndIf}

   ${IfNot} ${FileExists} "$PROGRAMFILES\Windows Mail\wab.exe"
     ${DelWarn} ${DelWinContacts} "$(SecDelWinContacts)"
   ${EndIf}
!endif

   ${IfNot} ${FileExists} "$PROGRAMFILES\MSN\MSNCoreFiles\Install\msnsusii.exe"
     ${DelWarn} ${DelMSNLnk} "$(SecDelMSNLnk)"
   ${EndIf}

!ifndef VISPA
   ${IfNot} ${FileExists} "$PROGRAMFILES\Messenger\msmsgs.exe"
     ${DelWarn} ${DelMessengerLnk} "$(SecDelMessengerLnk)"
   ${EndIf}
!endif ;VISPA

   ${IfNot} ${FileExists} "$SYSDIR\wupdmgr.exe"
     ${DelWarn} ${DelWinUpdate} "$(SecDelWinUpdate)"
   ${EndIf}
   !ifdef VISPA
     ${DelWarn} ${DelWelcomeCenter} "$(SecDelWelcomeCenter)"

     ${IfNot} ${FileExists} "$WINDIR\ehome\ehshell.exe"
       ${DelWarn} ${DelWinMediaCenter} "$(SecDelWinMediaCenter)"
     ${EndIf}

     ${DelWarn} ${DelWinUltExtras} "$(SecDelWinUltExtras)"
     
     ${IfNot} ${FileExists} "$PROGRAMFILES\Windows Collaboration\WinCollab.exe"
       ${DelWarn} ${DelWinMeetSpace} "$(SecDelWinMeetSpace)"
     ${EndIf}
   !endif ;VISPA
   !ifndef VISPA
     ${DelWarn} ${DelWinCatalog} "$(SecDelWinCatalog)"
     ${DelWarn} ${DelProgAccess} "$(SecDelProgAccess)"
   !endif ;VISPA
   ${DelWarn} ${DelMsBookmarks} "$(SecDelMsBookmarks)"
   ${DelWarn} ${DelSamplePictures} "$(SecDelSamplePictures)"
   ${DelWarn} ${DelSampleMusic} "$(SecDelSampleMusic)"
   !ifdef VISPA
     ${DelWarn} ${DelSampleVideos} "$(SecDelSampleVideos)"
   !endif ;VISPA
   ${DelWarn} ${DelSamplePlaylists} "$(SecDelSamplePlaylists)"
   ${DelWarn} ${DelBitmaps} "$(SecDelBitmaps)"
   ${DelWarn} ${DelPrefetch} "$(SecDelPrefetch)"
   !ifdef VISPA
	${DelWarn} ${DelUpdCache} "$(SecDelUpdCache)"
   !endif ;VISPA

   StrCmp $Warning "" End

   MessageBox MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION "$(MBNoRestorePre)$\n$Warning$\n$\n$(MBNoRestorePost)" IDYES End
   StrCpy $Warning ""
   Abort

   End:
 FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
 Function LicenseShow
;  checks if license was displayed before, skips license if true
   SendMessage $HWNDPARENT ${WM_SETTEXT} 0 `STR:${SHORTNAME} $Caption`
   IfSilent End
   StrCmp $Passive "1" 0 +2
   Abort
   StrCmp $ShowLicense 1 End
   IfFileExists "$APPDATA\${LOWERCASE}.ini" 0 End
   ReadINIStr $0 "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "LicenseAgreed"
   StrCmp $0 "1" 0 +2
   Abort
  End:
 FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
 Function LicenseLeave
;  writes license agreement to .ini file
   StrCmp $Output "1" +2
   WriteINIStr "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "LicenseAgreed" "1"
 FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
  Function ioPage
	!insertmacro MUI_HEADER_TEXT "$(LabelSettings)" "$(LabelDescription)"
	
	${If} $Output == "1"
	    ${GetFileName} "$SaveFile" "$0"
	    StrCpy $Caption "[$0]"
		Abort
	${ElseIf} $Output == "2"
	    ${GetFileName} "$RegFile" "$0"
	    StrCpy $Caption "[$0]"
		Abort
	${ElseIf} $Parameter == "/restore"
		StrCpy $Caption "[/restore]"
		Abort
	${ElseIf} $Force == 1
		StrCpy $Caption "[/force]"
	${ElseIfNot} $Input == ""
		${GetFileName} "$Input" "$0"
	    StrCpy $Caption "[$0]"
	    Abort
	${EndIf}
	
	SendMessage $HWNDPARENT ${WM_SETTEXT} 0 `STR:${SHORTNAME} $Caption`
	
	nsDialogs::Create /NOUNLOAD 1018
	Pop $preDialog

	${If} $preDialog == error
		Abort
	${EndIf}
	
	LockWindow on
	
	#nsDialogs::SelectFileDialog /NOUNLOAD save "" "xpy Batch|*.xpy"
	${NSD_CreateLabel} 0 0 100% 32 "$(LabelModeDesc1)" 
	Pop $LabelTop
	
	${NSD_CreateRadioButton} 8 38 100% 16 "$(LabelModeChange)"
	Pop $ButtonMake
	GetFunctionAddress $0 SelectButton
	nsDialogs::OnClick /NOUNLOAD $ButtonMake $0
	
	${NSD_CreateRadioButton} 8 56 100% 16 "$(LabelModeRestore)"
	Pop $ButtonRestore
	
	ReadIniStr $0 "$APPDATA\${SHORTNAME}.ini" "${SHORTNAME}" "FirstRun"
    StrCmp $0 "" 0 +2
	EnableWindow $ButtonRestore 0
	GetFunctionAddress $0 SelectButton
	nsDialogs::OnClick /NOUNLOAD $ButtonRestore $0
	
	${NSD_CreateGroupbox} 0 50% 100% 50% "$(LabelProfiles)"
	Pop $GroupBox
	
	${NSD_CreateLabel} 0 80 100% 32 "$(LabelModeDesc2)" 
	Pop $LabelBotton
	
	${NSD_CreateFileRequest} 10 150 400 20 ""
	Pop $FileRequest
	EnableWindow $FileRequest 0
	GetFunctionAddress $0 onChangeFile
	nsDialogs::OnChange /NOUNLOAD $FileRequest $0
	
	${NSD_CreateBrowseButton} 415 150 25 20 "..."
	Pop $ButtonBrowse
	GetFunctionAddress $0 ClickBrowse
	nsDialogs::OnClick /NOUNLOAD $ButtonBrowse $0
	EnableWindow $ButtonBrowse 0
	
	${NSD_CreateRadioButton} 12 175 90 24 "$(LabelLoadProfile)"
	Pop $ButtonLoad
	GetFunctionAddress $0 SelectLoad
	nsDialogs::OnClick /NOUNLOAD $ButtonLoad $0
	
	${NSD_CreateRadioButton} 102 175 90 24 "$(LabelSaveProfile)"
	Pop $ButtonSave
	GetFunctionAddress $0 SelectSave
	nsDialogs::OnClick /NOUNLOAD $ButtonSave $0
	
	${NSD_CreateRadioButton} 203 175 170 24 "$(LabelRegProfile)"
	Pop $ButtonReg
	GetFunctionAddress $0 SelectReg
	nsDialogs::OnClick /NOUNLOAD $ButtonReg $0
	
	Call onChangeFile
	
	GetDlgItem $0 $HWNDPARENT 3
    ShowWindow $0 0
	
	#disable next button
	GetDlgItem $0 $HWNDPARENT 1
    EnableWindow $0 0
	
	${IfNot} $Passive == "1"
          nsDialogs::Show
	${EndIf}
	
  FunctionEnd
  
  Function SelectButton  
    Pop $0 # HWND
	
	${If} $0 == error
		Abort
	${EndIf}
	
	EnableWindow $FileRequest 0
	SetCtlColors $FileRequest "" ""
	EnableWindow $ButtonBrowse 0
	
	#enable next button
	GetDlgItem $0 $HWNDPARENT 1 
	EnableWindow $0 1
  FunctionEnd
  
  Function SelectLoad  
    Pop $0 # HWND
	
	${If} $0 == error
		Abort
	${EndIf}
	
	${IfNot} $LoadFile == ""
		SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:$LoadFile"
	${Else}
		SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:"
	${EndIf}
	
	EnableWindow $FileRequest 1	
	#SetCtlColors $FileRequest "" ${REQUIRED}
	EnableWindow $ButtonBrowse 1
  FunctionEnd
  
  Function SelectSave
    Pop $0 # HWND
	
	${If} $0 == error
		Abort
	${EndIf}
	
	${NSD_GetText} $FileRequest $1
	
	${If} $SaveFile != ""
		#${GetFileExt} $SaveFile $0
		#StrCmp $0 "${LOWERCASE}" +2
		#StrCpy $SaveFile "$SaveFile.${LOWERCASE}"
		SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:$SaveFile"
	${Else}
		SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:$DESKTOP\$User.$ComputerName.${LOWERCASE}"
	${EndIf}
	Call SelectButton
	EnableWindow $FileRequest 1
	EnableWindow $ButtonBrowse 1
  FunctionEnd
  
  Function SelectReg
    Pop $0 # HWND
	
	${If} $0 == error
		Abort
	${EndIf}
	
	${NSD_GetText} $FileRequest $1
	
	${IfNot} $RegFile == ""
		#${GetFileExt} $SaveFile $0
		#StrCmp $0 "reg" +2
		#StrCpy $SaveFile "$SaveFile.reg"
		SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:$RegFile"
	${Else}
		SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:$DESKTOP\$User.$ComputerName.reg"
	${EndIf}
	Call SelectButton
	EnableWindow $FileRequest 1
	EnableWindow $ButtonBrowse 1
  FunctionEnd
  
  Function ClickBrowse
    Pop $0 # HWND
	
	${If} $0 == error
		Abort
	${EndIf}
	
	${NSD_GetState} $ButtonLoad $1
	${NSD_GetState} $ButtonSave $2
	${NSD_GetState} $ButtonReg $3
	${NSD_GetText} $FileRequest $4
	
    ${If} $1 == "1" #LOAD
		nsDialogs::SelectFileDialog LOAD "" "${SHORTNAME} Batch File|*.${LOWERCASE}|All Files|*.*"
		Pop $0
	${ElseIf} $2 == "1" #SAVE
		nsDialogs::SelectFileDialog SAVE "$4" "${SHORTNAME} Batch File|*.${LOWERCASE}|All Files|*.*"
		Pop $0
		${GetFileExt} "$0" $4
		StrCmp $4 "${LOWERCASE}" +2
		StrCpy $0 "$0.${LOWERCASE}"
	${ElseIf} $3 == "1" #SAVE
		nsDialogs::SelectFileDialog SAVE "$4" "${SHORTNAME} Registration File|*.reg|All Files|*.*"
		Pop $0
		${GetFileExt} "$0" $4
		StrCmp $4 "reg" +2
		StrCpy $0 "$0.reg"
	${EndIf}
	
	SendMessage $FileRequest ${WM_SETTEXT} 0 "STR:$0"
  FunctionEnd
  
  Function onChangeFile
	Pop $0 # HWND
	${NSD_GetText} $FileRequest $1
	${NSD_GetState} $ButtonLoad $2
	${NSD_GetState} $ButtonSave $3
	${NSD_GetState} $ButtonReg $4
	
	${If} $2 == "1"
		${IfNot} $1 == ""
			${If} ${FileExists} "$1"
				SetCtlColors $FileRequest "" "${VALID}"
				GetDlgItem $0 $HWNDPARENT 1 
				EnableWindow $0 1
				StrCpy $LoadFile $1
			${Else}
				SetCtlColors $FileRequest "" ${INVALID}
				GetDlgItem $0 $HWNDPARENT 1 
				EnableWindow $0 0
			${EndIf}
		${Else}
			SetCtlColors $FileRequest "" ${REQUIRED}
			GetDlgItem $0 $HWNDPARENT 1 
			EnableWindow $0 0
		${EndIf}
	${ElseIf} $3 == "1"
		StrCpy $SaveFile $1
	${ElseIf} $4 == "1"
		StrCpy $RegFile $1
	${EndIf}
	
	LockWindow off
FunctionEnd
  
  Function ioPageLeave #temp
    ${NSD_GetState} $ButtonMake $0
	${NSD_GetState} $ButtonRestore $1
	${NSD_GetState} $ButtonLoad $2
	${NSD_GetState} $ButtonSave $3
	${NSD_GetState} $ButtonReg $4
	${NSD_GetText} $FileRequest $5
	
	${If} $0 == "1"
	    InstTypeSetText 6 ""
	    InstTypeSetText 7 ""
	    InstTypeSetText 8 ""
	    InstTypeSetText 9 ""
	    InstTypeSetText 10 ""
	    InstTypeSetText 11 ""
	    InstTypeSetText 12 ""
	  !ifndef MINIXPY
	    Call UnSelectUnSections
	    Call AutoDetect
	  !endif ;MINIXPY
    ${ElseIf} $1 == "1"
		${If} $Force == 1
			StrCpy $Caption "[/force /restore]"
		${Else}
			StrCpy $Caption "[/restore]"
		${EndIf}
		Call Restore		
	${ElseIf} $2 == "1"
	    StrCpy $Input "$5"
		Call ValidateInput
		${GetFileName} "$Input" "$0"
	    StrCpy $Caption "[$0]"
	${ElseIf} $3 == "1"
	${OrIf} $4 == "1"
		${If} ${FileExists} "$5"
			MessageBox MB_YESNO|MB_ICONQUESTION "$(MBOverwrite)" IDYES +2
			Abort
			Delete "$5"			
		${EndIf}
		
/*		${GetParent} $4 $6
		${IsWritable} $6 $7
		${If} $7 == "1"
			MessageBox MB_OK|MB_ICONEXCLAMATION "Path doesn't exist or is read-only"
			Abort
		${EndIf}
*/

		${GetFileName} $5 $OutfileName
		
		${If} $3 == 1
			StrCpy $Output "1"
		${Else}
			StrCpy $Output "2"
		${EndIf}
		InstTypeSetText 6 ""
	    InstTypeSetText 7 ""
	    InstTypeSetText 8 ""
	    InstTypeSetText 9 ""
	    InstTypeSetText 10 ""
	    InstTypeSetText 11 ""
	    InstTypeSetText 12 ""
	  !ifndef MINIXPY
	    Call UnSelectUnSections
	    Call AutoDetect
	  !endif ;MINIXPY
	  StrCpy $Caption "[$OutfileName]" ;/file
	${EndIf}
  FunctionEnd

 Function io2Page
;       -displays custom page after the components page, allows further input
;       -checks if pre-defined search-engine is valid
;       -checks if firefox/thunderbird is installed and adds more features to ie/mail dropdown
 	StrCmp $Restore "1" 0 +2
 	Abort
 	
   	nsDialogs::Create /NOUNLOAD 1018
	Pop $Dialog

	${If} $Dialog == error
		Abort
	${EndIf}
	
	SendMessage $HWNDPARENT ${WM_SETTEXT} 0 `STR:${SHORTNAME} $Caption`
	
	#LockWindow on ;freezes app
	
	${NSD_CreateCheckBox} 0 5 100% 16 "$(LabelRestorePoint)"
	Pop $CheckBox
	
	${If} $Input != ""
          ReadINIStr $0 "$Input" "${SHORTNAME}" "RestorePoint"
          ${If} $0 == "1"
            SendMessage $CheckBox ${BM_SETCHECK} ${BST_CHECKED} 0
          ${Else}
            SendMessage $CheckBox ${BM_SETCHECK} ${BST_UNCHECKED} 0
          ${EndIf}
	${ElseIf} $Output == "2"
		SendMessage $CheckBox ${BM_SETCHECK} ${BST_UNCHECKED} 0
		EnableWindow $CheckBox 0
    ${Else}
		IfSilent +2
		SendMessage $CheckBox ${BM_SETCHECK} ${BST_CHECKED} 0
	${EndIf}
	
	
    ${NSD_CreateGroupBox} 0 35 100% 175 "$(LabelSettings)"
	Pop $GroupBox
	
	${NSD_CreateLabel} 18 60 200 16 "$(LabelDefaultSearch):"
	Pop $SearchLabel

	${NSD_CreateDropList} 18 80 200 16 0
	Pop $SearchEngine
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:A9 (a9.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Altavista (altavista.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Ask (ask.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Baidu (baidu.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Bing (bing.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Google (google.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Ixquick (ixquick.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Metacrawler (metacrawler.com)"
	SendMessage $SearchEngine ${CB_ADDSTRING} 0 "STR:Yahoo! (yahoo.com)"

	${If} $SearchEngineIni == ""
          ${If} "${SEARCHENGINE}" == "A9 (a9.com)" ; validate defined search engine
          ${OrIf} "${SEARCHENGINE}" == "Altavista (altavista.com)"
          ${OrIf} "${SEARCHENGINE}" == "Ask (ask.com)"
          ${OrIf} "${SEARCHENGINE}" == "Baidu (baidu.com)"
		  ${OrIf} "${SEARCHENGINE}" == "Bing (bing.com)"
          ${OrIf} "${SEARCHENGINE}" == "Google (google.com)"
          ${OrIf} "${SEARCHENGINE}" == "Ixquick (ixquick.com)"
          ${OrIf} "${SEARCHENGINE}" == "Metacrawler (metacrawler.com)"
          ${OrIf} "${SEARCHENGINE}" == "Yahoo! (yahoo.com)"
          SendMessage $SearchEngine ${CB_FINDSTRINGEXACT} -1 "STR:${SEARCHENGINE}" $0
        ${Else}
          SendMessage $SearchEngine ${CB_FINDSTRINGEXACT} -1 "STR:Google (google.com)" $0
	${EndIf}
      ${Else}
        SendMessage $SearchEngine ${CB_FINDSTRINGEXACT} -1 "STR:$SearchEngineIni" $0
      ${EndIf}
	
	SendMessage $SearchEngine ${CB_SETCURSEL} $0 ""
	
	SectionGetFlags ${IESearchPage} $0
	SectionGetFlags ${IESearchScope} $1

	${If} $0 == "1"
	${OrIf} $1 == "1"
		EnableWindow $SearchEngine 1
	${Else}
	       EnableWindow $SearchEngine 0
	${EndIf}

#------- Maximum Connections	
	${NSD_CreateLabel} 230 60 200 16 "$(LabelMaxConn):"
	Pop $MaxConnectionsLabel

	${NSD_CreateDropList} 230 80 36 16 ""
	Pop $MaxConnections
	
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:8"
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:12"
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:16"
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:24"
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:32"
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:48"
	SendMessage $MaxConnections ${CB_ADDSTRING} 0 "STR:64"
	
	ReadRegStr $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Internet Settings" "MaxConnectionsPerServer"
	${If} $1 > "4" ;4=Windows XP default
	${AndIf} $1 != ""
		IfSilent +2
		SendMessage $MaxConnections ${CB_FINDSTRINGEXACT} -1 "STR:$1" $0
	${Else}
		SendMessage $MaxConnections ${CB_FINDSTRINGEXACT} -1 "STR:32" $0
	${EndIf}
	
	SendMessage $MaxConnections ${CB_SETCURSEL} $0 ""
	
	SectionGetFlags ${IEMaxConn} $0

	${If} $0 == "1"
		EnableWindow $MaxConnections 1
	${Else}
	    EnableWindow $MaxConnections 0
	${EndIf}
	
#-------
	SetShellVarContext all
#-------InternetExplorer
	${NSD_CreateLabel} 18 110 200 16 "$(LabelIeShortcut):"
	Pop $IELabel

	${NSD_CreateDropList} 18 130 200 16 0
	Pop $IEShortcut
	SendMessage $IEShortcut ${CB_ADDSTRING} 0 "STR:$(LabelDelShortcut)"
	
	IfFileExists "$DESKTOP\*Firefox*.lnk" 0 +2
	SendMessage $IEShortcut ${CB_ADDSTRING} 0 "STR:$(LabelFxTarget)"

	ReadRegStr $0 HKLM "Software\Mozilla\Mozilla Firefox" "CurrentVersion"
	${If} $0 == ""
	    SendMessage $IEShortcut ${CB_ADDSTRING} 0 "STR:$(LabelFxDownload)"
	    IfSilent +3
	    SendMessage $IEShortcut ${CB_FINDSTRINGEXACT} -1 "STR:$(LabelFxDownload)" $0
	    Goto +2
	    SendMessage $IEShortcut ${CB_FINDSTRINGEXACT} -1 "STR:$(LabelDelShortcut)" $0
	${Else}
		SendMessage $IEShortcut ${CB_FINDSTRINGEXACT} -1 "STR:$(LabelDelShortcut)" $0
	${EndIf}

	SendMessage $IEShortcut ${CB_SETCURSEL} $0 ""
	
	SectionGetFlags ${DelIELnk} $0

	${If} $0 == "1"
		EnableWindow $IEShortcut 1
	${Else}
	    EnableWindow $IEShortcut 0
	${EndIf}
#-------Outlook
    !ifndef VISPA
	  ${NSD_CreateLabel} 230 110 200 16 "$(LabelOutlookShortcut):"
	!else ;VISPA
	  ${NSD_CreateLabel} 230 110 200 16 "$(LabelWinMailShortcut):"
	!endif ;VISPA
	Pop $OutlookLabel

	${NSD_CreateDropList} 230 130 200 16 0
	Pop $OutlookShortcut
	SendMessage $OutlookShortcut ${CB_ADDSTRING} 0 "STR:$(LabelDelShortcut)"
	
	IfFileExists "$DESKTOP\*Thunderbird*.lnk" 0 +2
	SendMessage $OutlookShortcut ${CB_ADDSTRING} 0 "STR:$(LabelTbTarget)"
	SendMessage $OutlookShortcut ${CB_FINDSTRINGEXACT} -1 "STR:$(LabelDelShortcut)" $0
	SendMessage $OutlookShortcut ${CB_SETCURSEL} $0 ""

	!ifndef VISPA
		SectionGetFlags ${DelOutExLnk} $0
	!else ;VISPA
		SectionGetFlags ${DelWinMail} $0
	!endif ;VISPA

	${If} $0 == "1"
		EnableWindow $OutlookShortcut 1
	${Else}
	       EnableWindow $OutlookShortcut 0
	${EndIf}
	
#------- RDP Port
	${NSD_CreateLabel} 18 160 200 16 "$(LabelRDPPort):"
	Pop $RDPLabel

	${NSD_CreateText} 18 180 42 21 "3389"
	Pop $RDP
	GetFunctionAddress $0 onChangeRDP
	nsDialogs::OnChange /NOUNLOAD $RDP $0
	
	SectionGetFlags ${GenRDPPort} $0

	${If} $0 == "1"
		EnableWindow $RDP 1
	${Else}
	    EnableWindow $RDP 0
	${EndIf}
	
#-------
        SetShellVarContext current
        ${IfNot} $Passive == "1"
          nsDialogs::Show
        ${EndIf}
  FunctionEnd
 
  Function io2PageLeave
;          -writes variables for search-engine setting
;          -writes variable for ie-shortcut setting
;          -writes variable for outlook/mail-shortcut setting
    ${NSD_GetState} $CheckBox $CheckBox
    ${NSD_GetText} $SearchEngine $SearchEngine
    ${NSD_GetState} $MaxConnections $MaxConnections
    Push $SearchEngine
    Call SearchEngines
	   
    ${NSD_GetText} $IEShortcut $IEShortcut
    ${NSD_GetText} $OutlookShortcut $OutlookShortcut
	
	${NSD_GetText} $RDP $RDP
	
	Push "${NUMERIC}"
	Push "$RDP"
	Call StrCSpnReverse
	Pop $0
	
	${If} $RDP > 65535
	${OrIf} $RDP == ""
	${OrIf} $0 != ""
		MessageBox MB_OK|MB_ICONEXCLAMATION "You need to specify a valid RDP port (0-65535)" #translate
		#SetCtlColors $RDP "" ${INVALID}
		Abort
	#${ElseIf} $0 == ""
	#	SetCtlColors $RDP "" ${REQUIRED}
	#	Abort
	#${Else}
	#	SetCtlColors $RDP "" ""
	#	Abort
	${EndIf}
	
	${If} $Output == "1"
		WriteINIStr "$SaveFile" "${LOWERCASE}" "Version" "${VERSION}"
	${ElseIf} $Output == "2"
		FileOpen $0 "$RegFile" w
		FileWrite $0 "Windows Registry Editor Version 5.00"
		FileClose $0
	${Else}
		WriteINIStr "$APPDATA\${LOWERCASE}.ini" "${LOWERCASE}" "Version" "${VERSION}"
	${EndIf}
  FunctionEnd
  
  Function onChangeRDP
	Pop $0 # HWND
	
	${NSD_GetText} $RDP $0
	
	Push "${NUMERIC}"
	Push "$0"
	Call StrCSpnReverse
	Pop $1
	
	${If} $0 > 65535
	#${OrIf} $0 == ""
	${OrIf} $1 != ""
	#	MessageBox MB_OK|MB_ICONEXCLAMATION "You need to specify a valid RDP port (0-65535)" #translate
		SetCtlColors $RDP "" ${INVALID}
		Abort
	${ElseIf} $0 == ""
		SetCtlColors $RDP "" ${REQUIRED}
		Abort
	${Else}
		SetCtlColors $RDP "" ""
		Abort
	${EndIf}
	
	LockWindow off
	
  FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
  Function InstfilesShow
	w7tbp::Start
    SendMessage $HWNDPARENT ${WM_SETTEXT} 0 `STR:${SHORTNAME} $Caption`
  FunctionEnd
!endif ;MINIXPY

!ifndef LANGUAGE
  Function LangSelect
;   displays a language dialog when launched with /lang switch
    Push ""

    !ifdef LANG_ENGLISH
      Push ${LANG_ENGLISH}
      Push English
    !endif

    !ifdef LANG_BULGARIAN
      Push ${LANG_BULGARIAN}
      Push Bulgarian
    !endif
    
    !ifdef LANG_CZECH
      Push ${LANG_CZECH}
      Push Czech
    !endif
    
    !ifdef LANG_FRENCH
      Push ${LANG_FRENCH}
      Push French
    !endif
    
    !ifdef LANG_GERMAN
      Push ${LANG_GERMAN}
      Push German
    !endif
    
    !ifdef LANG_HUNGARIAN
      Push ${LANG_HUNGARIAN}
      Push Hungarian
    !endif
    
    !ifdef LANG_ITALIAN
      Push ${LANG_ITALIAN}
      Push Italian
    !endif
    
    !ifdef LANG_JAPANESE
      Push ${LANG_JAPANESE}
      Push Japanese
    !endif
    
    !ifdef LANG_POLISH
      Push ${LANG_POLISH}
      Push Polish
    !endif
    
    !ifdef LANG_RUSSIAN
      Push ${LANG_RUSSIAN}
      Push Russian
    !endif
    
    !ifdef LANG_SPANISH
      Push ${LANG_SPANISH}
      Push Spanish
    !endif
	
	!ifdef LANG_SWEDISH
      Push ${LANG_SWEDISH}
      Push Swedish
    !endif
    
    !ifdef LANG_TURKISH
      Push ${LANG_TURKISH}
      Push Turkish
    !endif
    
    !ifdef LANG_UKRAINIAN
      Push ${LANG_UKRAINIAN}
      Push Ukrainian
    !endif
    
    Push A ; A means auto count languages
         ;   for the auto count to work the first empty push (Push "") must remain
    LangDLL::LangDialog "Program Language" "Please select a language for ${SHORTNAME}"
    Pop $LANGUAGE
    StrCmp $LANGUAGE "cancel" 0 +2
    Abort
  FunctionEnd
!endif
 
!ifndef MINIXPY
 Function Restore
; some (temporary?) settings for backward compability, don't quite remember!
  
   StrCpy $Restore "1"
   InstTypeSetText 0 ""
   InstTypeSetText 1 ""
   InstTypeSetText 2 ""
   InstTypeSetText 3 ""
   InstTypeSetText 4 ""
   InstTypeSetText 5 ""
   Call UnSelectSections
   
    ${RestoreSection} "General" "CompressedFolders" "${GenUnCompressedFolders}"
	${RestoreSection} "General" "RegWizC" "${GenUnRegWizC}"
	!ifndef VISPA
	  ${RestoreSection} "General" "ErrorRep" "${GenUnErrorRep}"
    !endif ;VISPA
    ${RestoreSection} "General" "LMHash" "${GenUnLMHash}"
    ${RestoreSection} "General" "WSHEnable" "${GenUnScriptHost}"
    ${RestoreSection} "General" "RemAssist2" "${GenUnRemAssist}"
    ${RestoreSection} "General" "InetOpen" "${GenUnInetOpen}"
    ${RestoreSection} "General" "RestrictAnon" "${GenUnRestrictAnon}"
    ${RestoreSection} "General" "NetCrawl" "${GenUnNetCrawl}"
    ${RestoreSection} "General" "HideComputer" "${GenUnHideComputer}"
	!ifndef VISPA
	 ${RestoreSection} "General" "RepInfect" "${GenUnRepInfect}"
	!endif ;VISPA
    ${RestoreSection} "General" "MediaSense" "${GenUnMediaSense}"
	!ifndef VISPA
	  ${RestoreSection} "General" "RegDone" "${GenUnClaimWinReg}"
	!endif ;VISPA
    ${RestoreSection} "General" "Prefetch" "${GenUnPrefetch}"
    ${RestoreSection} "General" "FastShutdn" "${GenUnFastShutdn}"
    ${RestoreSection} "General" "DelPagefile" "${GenUnDelPagefile}"
	!ifndef VISPA
	 ${RestoreSection} "General" "DelMRU" "${GenUnDelMRU}"
	 ${RestoreSection} "General" "RecentShares" "${GenUnRecentShares}"
	!endif ;VISPA
    ${RestoreSection} "General" "LastUser" "${GenUnLastUser}"
    ${RestoreSection} "General" "PriorityCtrl" "${GenUnPriorityCtrl}"
    !ifdef VISPA
	  ${RestoreSection} "General" "SysResponse" "${GenUnSysResponse}"
	  ${RestoreSection} "General" "DisableUAC" "${GenUnDisableUAC}"
	!endif
	${RestoreSection} "General" "RDPPort" "${GenUnRDPPort}"
	${RestoreSection} "General" "SpyNet" "${GenUnSpyNet}"
	
    ${RestoreSection} "Services" "ErrorRep" "${ServUnErrorRep}"
    ${RestoreSection} "Services" "AutoWinUpd" "${ServUnAutoWinUpd}"
    ${RestoreSection} "Services" "SecCenter" "${ServUnSecCenter}"
    ${RestoreSection} "Services" "AutoWinDefend" "${ServUnWinDefend}"
    ${RestoreSection} "Services" "TimeSync" "${ServUnTimeSync}"
    ${RestoreSection} "Services" "SchedTask" "${ServUnSchedTask}"
	!ifndef VISPA
	 ${RestoreSection} "Services" "Indexing" "${ServUnIndexing}"
	 ${RestoreSection} "Services" "DCOM" "${ServUnDCOM}"
	!endif ;VISPA
    ${RestoreSection} "Services" "Telnet" "${ServUnTelnet}"
    ${RestoreSection} "Services" "UPnP" "${ServUnUPnP}"
    ${RestoreSection} "Services" "UPnPDiscovery" "${ServUnUPnPDiscovery}"
	!ifndef VISPA
	 ${RestoreSection} "Services" "Messenger" "${ServUnMessenger}"
	 ${RestoreSection} "Services" "NetMeetingDesktop" "${ServUnNetMeetingDesktop}"
	!endif ;VISPA
    ${RestoreSection} "Services" "RPCLoc" "${ServUnRPCLoc}"
    ${RestoreSection} "Services" "RemReg" "${ServUnRemReg}"
	!ifndef VISPA
	 ${RestoreSection} "Services" "IcfIcs" "${ServUnIcfIcs}"
	!else ;VISPA
	 ${RestoreSection} "Services" "Firewall" "${ServUnFirewall}"
	!endif ;VISPA
    ${RestoreSection} "Services" "Imapi" "${ServUnImapi}"
    ${RestoreSection} "Services" "AudioSrv" "${ServUnAudioSrv}"
    ${RestoreSection} "Services" "WIA" "${ServUnWIA}"
	
    ${RestoreSection} "InternetExplorer" "AutoUpdates" "${IEUnAutoUpdates}"
    ${RestoreSection} "InternetExplorer" "SchedUpd" "${IEUnSchedUpd}"
    ${RestoreSection} "InternetExplorer" "WatsonDisabled" "${IEUnErrorRep}"
    ${RestoreSection} "InternetExplorer" "IntWinAuth" "${IEUnIntWinAuth}"
    ${RestoreSection} "InternetExplorer" "MaxConnPS" "${IEUnMaxConn}"
    ${RestoreSection} "InternetExplorer" "TabSettings" "${IEUnTabSettings}"
    ${RestoreSection} "InternetExplorer" "DelTempFiles" "${IEUnDelTempFiles}"
    ${RestoreSection} "InternetExplorer" "WebformComplete" "${IEUnWebformComplete}"
    ${RestoreSection} "InternetExplorer" "PasswordComplete" "${IEUnPasswordComplete}"
    ${RestoreSection} "InternetExplorer" "SearchPage" "${IEUnSearchPage}"
    ${RestoreSection} "InternetExplorer" "SearchScope" "${IEUnSearchScope}"
    ${RestoreSection} "InternetExplorer" "ActiveX1200" "${IEUnActiveX}"
    ${RestoreSection} "InternetExplorer" "JavaScript1400" "${IEUnJavaScript}"
    ${RestoreSection} "InternetExplorer" "SSL2" "${IEUnSSL2}"
    ${RestoreSection} "InternetExplorer" "PhishFilter" "${IEUnPhishFilter}"
    ${RestoreSection} "InternetExplorer" "SearchAsst" "${IEUnSearchAsst}"
    ${RestoreSection} "InternetExplorer" "404Search" "${IEUn404Search}"
    ${RestoreSection} "InternetExplorer" "BlankPage" "${IEUnBlankPage}"
    ${RestoreSection} "InternetExplorer" "DefaultPrompt" "${IEUnDefaultPrompt}"
    ${RestoreSection} "InternetExplorer" "InfoBar" "${IEUnInfoBar}"
	
    ${RestoreSection} "WindowsMediaPlayer" "AutoLicAcqu" "${WMPUnAutoLicAcqu}"
	!ifdef VISPA
	 ${RestoreSection} "WindowsMediaPlayer" "SilentDRM" "${WMPUnSilentDRM}"
	!endif ;VISPA
	!ifndef VISPA
	 ${RestoreSection} "WindowsMediaPlayer" "UpgradeMsg" "${WMPUnUpgradeMsg}"
	!endif ;VISPA
    ${RestoreSection} "WindowsMediaPlayer" "Library" "${WMPUnLibrary}"
    ${RestoreSection} "WindowsMediaPlayer" "MetadataRet" "${WMPUnMetadataRet}"
    ${RestoreSection} "WindowsMediaPlayer" "UsageTrack" "${WMPUnUsageTrack}"
	!ifdef VISPA
	  ${RestoreSection} "WindowsMediaPlayer" "SendUID" "${WMPUnSendUID}"
	!endif ;VISPA
	!ifndef VISPA
	 ${RestoreSection} "WindowsMediaPlayer" "AutoUpdates" "${WMPUnAutoUpdates}"
	 ${RestoreSection} "WindowsMediaPlayer" "NoMRU" "${WMPUnNoMRU}"
	!endif ;VISPA
    ${RestoreSection} "WindowsMediaPlayer" "AutoCodecDownl" "${WMPUnAutoCodecDownl}"
    ${RestoreSection} "WindowsMediaPlayer" "CDRecordMP3" "${WMPUnImportMP3}"
    ${RestoreSection} "WindowsMediaPlayer" "NoDRM" "${WMPUnNoDRM}"
	!ifndef VISPA
	 ${RestoreSection} "WindowsMediaPlayer" "AllowDeinst" "${WMPUnAllowDeinst}"
	 
	 ${RestoreSection} "WindowsMessenger" "WMRemOE" "${WMUnRemOE}"
	!endif ;VISPA
	 ${RestoreSection} "WindowsSearch" "Disable" "${WDSUnDisable}"
	 
	!ifndef VISPA
	 ${RestoreSection} "Usability" "BalloonTips" "${UsabUnBalloonTips}"
	!endif ;VISPA
    ${RestoreSection} "Usability" "LowDiskspace" "${UsabUnDiskSpace}"
	!ifndef VISPA
	 ${RestoreSection} "Usability" "CmdHere" "${UsabUnCmdHere}"
	 ${RestoreSection} "Usability" "CmdCompl" "${UsabUnCmdCompl}"
	!endif ;VISPA
    ${RestoreSection} "Usability" "EditNotepad" "${UsabUnEditNotepad}"
    ${RestoreSection} "Usability" "AutoRun" "${UsabUnAutoRun}"
	!ifndef VISPA
	 ${RestoreSection} "Usability" "SearchAsst" "${UsabUnSearchAsst}"
	!endif ;VISPA
    ${RestoreSection} "Usability" "CleanupWiz" "${UsabUnCleanupWiz}"
    ${RestoreSection} "Usability" "TaskGroup" "${UsabUnTaskGroup}"
    ${RestoreSection} "Usability" "ClassicStartMenu" "${UsabUnClassicStartMenu}"
    ${RestoreSection} "Usability" "ClassicLogon" "${UsabUnClassicLogon}"
    ${RestoreSection} "Usability" "ShutdownReasonOn" "${UsabUnShutdownReason}"
	!ifndef VISPA
	 ${RestoreSection} "Usability" "BarricadeRootFolder" "${UsabUnBarricade}"
	!endif ;VISPA
    ${RestoreSection} "Usability" "HiddenFiles" "${UsabUnHiddenFiles}"
    ${RestoreSection} "Usability" "ShowFileExt" "${UsabUnShowFileExt}"
    ${RestoreSection} "Usability" "ShowLNKExt" "${UsabUnShowLNKExt}"
    ${RestoreSection} "Usability" "ShowPIFExt" "${UsabUnShowPIFExt}"
    ${RestoreSection} "Usability" "ShowSCFExt" "${UsabUnShowSCFExt}"
    ${RestoreSection} "Usability" "ShowURLExt" "${UsabUnShowURLExt}"
    ${RestoreSection} "Usability" "FullPath" "${UsabUnFullPath}"
    ${RestoreSection} "Usability" "DisableThumbnails" "${UsabUnDisableThumbnails}"
    ${RestoreSection} "Usability" "DisableSounds" "${UsabUnDisableSounds}"
    ${RestoreSection} "Usability" "WinTheme" "${UsabUnWinTheme}"
	   
    ${RestoreSection} "ThirdParty" "AppleMobile" "${TPUnAppleMobile}"
    ${RestoreSection} "ThirdParty" "iPodService" "${TPUnIpodService}"
    ${RestoreSection} "ThirdParty" "GoogleUpdater" "${TPUnGoogleUpdater}"
    ${RestoreSection} "ThirdParty" "GoogleSAC" "${TPUnGoogleSAC}"
    ${RestoreSection} "Delete" "IELnk" "${DelUnIELnk}"
	!ifndef VISPA
	 ${RestoreSection} "Delete" "OutExLnk" "${DelUnOutExLnk}"
	!else ;VISPA
	 ${RestoreSection} "Delete" "WinMail" "${DelUnWinMail}"
	!endif ;VISPA
    ${RestoreSection} "Delete" "RecycleBin" "${DelUnRecycleBin}"
    ${RestoreSection} "Delete" "MyDocuments" "${DelUnMyDocuments}"
    ${RestoreSection} "Delete" "MyComputer" "${DelUnMyComputer}"
    ${RestoreSection} "Delete" "MyNetwork" "${DelUnMyNetwork}"
	!ifdef VISPA
	 ${RestoreSection} "Delete" "ControlPanel" "${DelUnControlPanel}"
	!endif ;VISPA
    ${RestoreSection} "Delete" "WMPLnk" "${DelUnWMPLnk}"
    ${RestoreSection} "Delete" "MovieMkLnk" "${DelUnMovieMkLnk}"
	!ifdef VISPA
	 ${RestoreSection} "Delete" "WinDVDMk" "${DelUnWinDVDMk}"
	 ${RestoreSection} "Delete" "WinPhotoGal" "${DelUnWinPhotoGal}"
	 ${RestoreSection} "Delete" "WinDefender" "${DelUnWinDefender}"
	 ${RestoreSection} "Delete" "WinFaxScan" "${DelUnWinFaxScan}"
	 ${RestoreSection} "Delete" "WinCalendar" "${DelUnWinCalendar}"
	 ${RestoreSection} "Delete" "WinContacts" "${DelUnWinContacts}"
	!endif ;VISPA
    ${RestoreSection} "Delete" "MSNLnk" "${DelUnMSNLnk}"
	!ifndef VISPA
	 ${RestoreSection} "Delete" "MessengerLnk" "${DelUnMessengerLnk}"
	!endif ;VISPA
    ${RestoreSection} "Delete" "WinUpdate" "${DelUnWinUpdate}"
	!ifdef VISPA
	 ${RestoreSection} "Delete" "WinMediaCenter" "${DelUnWinMediaCenter}"
	 ${RestoreSection} "Delete" "WinMeetSpace" "${DelUnWinMeetSpace}"
	!endif ;VISPA
	   
   Call unComponentsShow

 FunctionEnd
!endif ;MINIXPY

Function SelectSections
;  show & select all sections
   ${SelectSection} "${SecGeneral}" "" ""
   ${SelectSection} "${GenCompressedFolders}" "General" "CompressedFolders"
   ${SelectSection} "${GenRegWizC}" "General" "RegWizC"
   !ifndef VISPA
     ${SelectSection} "${GenErrorRep}" "General" "ErrorRep"
   !endif ;VISPA
   ${SelectSection} "${GenLMHash}" "General" "LMHash"
   !ifndef VISPA
     ${SelectSection} "${GenWGA}" "General" "WGA"
   !endif ;VISPA
   ${SelectSection} "${GenScriptHost}" "General" "WSHEnable"
   ${SelectSection} "${GenRemAssist}" "General" "RemAssist1"
   ${SelectSection} "${GenRestrictAnon}" "General" "RestrictAnon"
   ${SelectSection} "${GenInetOpen}" "General" "InetOpen"
   ${SelectSection} "${GenHideComputer}" "General" "HideComputer"
   !ifndef VISPA
     ${SelectSection} "${GenRepInfect}" "General" "RepInfect"
   !endif ;VISPA
   ${SelectSection} "${GenMediaSense}" "General" "MediaSense"
   !ifndef VISPA
     ${SelectSection} "${GenClaimWinReg}" "General" "RegDone"
   !endif ;VISPA
   ${SelectSection} "${GenPrefetch}" "General" "Prefetch"
   ${SelectSection} "${GenFastShutdn}" "General" "FastShutdn"
   ${SelectSection} "${GenDelPagefile}" "General" "DelPagefile"
   !ifndef VISPA
     ${SelectSection} "${GenDelMRU}" "General" "DelMRU"
     ${SelectSection} "${GenRecentShares}" "General" "RecentShares"
   !endif ;VISPA
   ${SelectSection} "${GenLastUser}" "General" "LastUser"
   ${SelectSection} "${GenPriorityCtrl}" "General" "PriorityCtrl"
   !ifdef VISPA
     ${SelectSection} "${GenSysResponse}" "General" "SysResponse"
     ${SelectSection} "${GenDisableUAC}" "General" "DisableUAC"
   !endif ;VISPA
   ${SelectSection} "${GenRDPPort}" "General" "RDPPort"
   ${SelectSection} "${GenSpyNet}" "General" "SpyNet"

   ${SelectSection} "${SecServices}" "" ""
   ${SelectSection} "${ServErrorRep}" "Services" "ErrorRep"
   ${SelectSection} "${ServAutoWinUpd}" "Services" "AutoWinUpd"
   ${SelectSection} "${ServSecCenter}" "Services" "SecCenter"
   ${SelectSection} "${ServWinDefend}" "Services" "WinDefend"
   ${SelectSection} "${ServTimeSync}" "Services" "TimeSync"
   ${SelectSection} "${ServSchedTask}" "Services" "SchedTask"
   !ifndef VISPA
     ${SelectSection} "${ServIndexing}" "Services" "Indexing"
     ${SelectSection} "${ServDCOM}" "Services" "DCOM"
   !endif ;VISPA
   ${SelectSection} "${ServTelnet}" "Services" "Telnet"
   ${SelectSection} "${ServUPnP}" "Services" "UPnP"
   ${SelectSection} "${ServUPnPDiscovery}" "Services" "UPnPDiscovery"
   !ifndef VISPA
     ${SelectSection} "${ServNetMeetingDesktop}" "Services" "NetMeetingDesktop"
   !endif ;VISPA
   ${SelectSection} "${ServRPCLoc}" "Services" "RPCLoc"
   ${SelectSection} "${ServRemReg}" "Services" "RemReg"
   !ifndef VISPA
     ${SelectSection} "${ServIcfIcs}" "Services" "IcfIcs"
   !else ;VISPA
     ${SelectSection} "${ServFirewall}" "Services" "Firewall"
   !endif ;VISPA
   ${SelectSection} "${ServImapi}" "Services" "Imapi"
   ${SelectSection} "${ServAudioSrv}" "Services" "AudioSrv"
   ${SelectSection} "${ServWIA}" "Services" "WIA"
   ${SelectSection} "${TPAppleMobile}" "ThirdParty" "AppleMobile"
   ${SelectSection} "${TPIpodService}" "ThirdParty" "iPodService"
   ${SelectSection} "${TPGoogleUpdater}" "ThirdParty" "GoogleUpdater"
   ${SelectSection} "${TPGoogleSAC}" "ThirdParty" "GoogleSAC"
   
   ${SelectSection} "${SecIExplore}" "InternetExplorer" ""
   ${SelectSection} "${IEAutoUpdates}" "InternetExplorer" "AutoUpdates"
   ${SelectSection} "${IESchedUpd}" "InternetExplorer" "SchedUpd"
   ${SelectSection} "${IEErrorRep}" "InternetExplorer" "WatsonDisabled"
   ${SelectSection} "${IEIntWinAuth}" "InternetExplorer" "IntWinAuth"
   ${SelectSection} "${IEMaxConn}" "InternetExplorer" "MaxConnPS"
   ${SelectSection} "${IETabSettings}" "InternetExplorer" "TabSettings"
   ${SelectSection} "${IEuplddrvinfo}" "InternetExplorer" "uplddrvinfo"
   ${SelectSection} "${IEDelTempFiles}" "InternetExplorer" "DelTempFiles"
   ${SelectSection} "${IEWebformComplete}" "InternetExplorer" "WebformComplete"
   ${SelectSection} "${IEPasswordComplete}" "InternetExplorer" "PasswordComplete"
   ${SelectSection} "${IEAlexa}" "InternetExplorer" "Alexa"
   ${SelectSection} "${IESearchPage}" "InternetExplorer" "SearchPage"
   ${SelectSection} "${IESearchScope}" "InternetExplorer" "SearchScopeDefault"
   ${SelectSection} "${IEActiveX}" "InternetExplorer" "ActiveX1200"
   ${SelectSection} "${IEJavaScript}" "InternetExplorer" "JavaScript1400"
   ${SelectSection} "${IESSL2}" "InternetExplorer" "SSL2"
   ${SelectSection} "${IEPhishFilter}" "InternetExplorer" "PhishFilter"
   ${SelectSection} "${IESearchAsst}" "InternetExplorer" "SearchAsst"
   ${SelectSection} "${IE404Search}" "InternetExplorer" "404Search"
   ${SelectSection} "${IEBlankPage}" "InternetExplorer" "BlankPage"
   ${SelectSection} "${IEDefaultPrompt}" "InternetExplorer" "DefaultPrompt"
   ${SelectSection} "${IEInfoBar}" "InternetExplorer" "InfoBar"
   ${SelectSection} "${IERemove}" "InternetExplorer" "IERemove"

   ${SelectSection} "${SecWMP}" "" ""
   ${SelectSection} "${WMPAutoLicAcqu}" "WindowsMediaPlayer" "AutoLicAcqu"
   !ifdef VISPA
     ${SelectSection} "${WMPSilentDRM}" "WindowsMediaPlayer" "SilentDRM"
   !endif ;VISPA
   !ifndef VISPA
     ${SelectSection} "${WMPUpgradeMsg}" "WindowsMediaPlayer" "UpgradeMsg"
   !endif ;VISPA
   ${SelectSection} "${WMPLibrary}" "WindowsMediaPlayer" "Library"
   ${SelectSection} "${WMPMetadataRet}" "WindowsMediaPlayer" "MetadataRet"
   ${SelectSection} "${WMPUsageTrack}" "WindowsMediaPlayer" "UsageTrack"
   !ifdef VISPA
     ${SelectSection} "${WMPSendUID}" "WindowsMediaPlayer" "SendUID"
   !endif ;VISPA
   !ifndef VISPA
     ${SelectSection} "${WMPAutoUpdates}" "WindowsMediaPlayer" "AutoUpdates"
     ${SelectSection} "${WMPNoMRU}" "WindowsMediaPlayer" "NoMRU"
   !endif ;VISPA
   ${SelectSection} "${WMPAutoCodecDownl}" "WindowsMediaPlayer" "AutoCodecDownl"
   ${SelectSection} "${WMPImportMP3}" "WindowsMediaPlayer" "CDRecordMP3"
   ${SelectSection} "${WMPNoDRM}" "WindowsMediaPlayer" "NoDRM"
   !ifndef VISPA
     ${SelectSection} "${WMPAllowDeinst}" "WindowsMediaPlayer" "AllowDeinst"
     ${SelectSection} "${SecWinMessenger}" "" ""
     ${SelectSection} "${WMRemOE}" "WindowsMessenger" "WMRemOE"
     ${SelectSection} "${WMUninstall}" "WindowsMessenger" "Uninstall"
   !endif ;VISPA
   
   ${SelectSection} "${SecWinSearch}" "" ""
   ${SelectSection} "${WDSDisable}" "WindowsSearch" "Disable"
   ${SelectSection} "${WDSRemove}" "WindowsSearch" "Uninstall"
   ${SelectSection} "${SecUsability}" "" ""
   !ifndef VISPA
     ${SelectSection} "${UsabBalloonTips}" "Usability" "BalloonTips"
   !endif ;VISPA
   ${SelectSection} "${UsabDiskSpace}" "Usability" "LowDiskspace"
   !ifndef VISPA
     ${SelectSection} "${UsabCmdHere}" "Usability" "CmdHere"
     ${SelectSection} "${UsabCmdCompl}" "Usability" "CmdCompl"
   !endif ;VISPA
   ${SelectSection} "${UsabEditNotepad}" "Usability" "EditNotepad"
   ${SelectSection} "${UsabAutoRun}" "Usability" "AutoRun"
   !ifndef VISPA
     ${SelectSection} "${UsabSearchAsst}" "Usability" "SearchAsst"
   !endif ;VISPA
   ${SelectSection} "${UsabCleanupWiz}" "Usability" "CleanupWiz"
   ${SelectSection} "${UsabTaskGroup}" "Usability" "TaskGroup"
   ${SelectSection} "${UsabClassicStartMenu}" "Usability" "ClassicStartMenu"
   ${SelectSection} "${UsabClassicLogon}" "Usability" "ClassicLogon"
   ${SelectSection} "${UsabShutdownReason}" "Usability" "ShutdownReasonOn"
   !ifndef VISPA
     ${SelectSection} "${UsabBarricade}" "Usability" "BarricadeRootFolder"
   !endif ;VISPA
   ${SelectSection} "${UsabHiddenFiles}" "Usability" "HiddenFiles"
   ${SelectSection} "${UsabShowFileExt}" "Usability" "ShowFileExt"
   ${SelectSection} "${UsabShowLNKExt}" "Usability" "ShowLNKExt"
   ${SelectSection} "${UsabShowPIFExt}" "Usability" "ShowPIFExt"
   ${SelectSection} "${UsabShowSCFExt}" "Usability" "ShowSCFExt"
   ${SelectSection} "${UsabShowURLExt}" "Usability" "ShowURLExt"
   ${SelectSection} "${UsabFullPath}" "Usability" "FullPath"
   ${SelectSection} "${UsabDisableThumbnails}" "Usability" "DisableThumbnails"
   ${SelectSection} "${UsabDisableSounds}" "Usability" "DisableSounds"
   ${SelectSection} "${UsabWinTheme}" "Usability" "WinTheme"
   
   ${SelectSection} "${SecDelete}" "" ""
   ${SelectSection} "${DelIELnk}" "Delete" "IELnk"
   !ifndef VISPA
     ${SelectSection} "${DelOutExLnk}" "Delete" "OutExLnk"
   !else ;VISPA
     ${SelectSection} "${DelWinMail}" "Delete" "WinMail"
   !endif ;VISPA
   ${SelectSection} "${DelRecycleBinLnk}" "Delete" "RecycleBin"
   ${SelectSection} "${DelMyDocumentsLnk}" "Delete" "MyDocuments"
   ${SelectSection} "${DelMyComputerLnk}" "Delete" "MyComputer"
   ${SelectSection} "${DelMyNetworkLnk}" "Delete" "MyNetwork"
   !ifdef VISPA
     ${SelectSection} "${DelControlPanelLnk}" "Delete" "MyNetwork"
   !endif ;VISPA
   ${SelectSection} "${DelWMPLnk}" "Delete" "WMPLnk"
   ${SelectSection} "${DelMovieMkLnk}" "Delete" "MovieMkLnk"
   !ifdef VISPA
     ${SelectSection} "${DelWinDVDMk}" "Delete" "WinDVDMk"
     ${SelectSection} "${DelWinPhotoGal}" "Delete" "WinPhotoGal"
     ${SelectSection} "${DelWinDefender}" "Delete" "WinDefender"
     ${SelectSection} "${DelWinLiveDl}" "Delete" "WinLiveDl"
     ${SelectSection} "${DelWinFaxScan}" "Delete" "WinFaxScan"
     ${SelectSection} "${DelWinCalendar}" "Delete" "WinCalendar"
     ${SelectSection} "${DelWinContacts}" "Delete" "WinContacts"
   !endif ;VISPA
   ${SelectSection} "${DelMSNLnk}" "Delete" "MSNLnk"
   !ifndef VISPA
     ${SelectSection} "${DelMessengerLnk}" "Delete" "MessengerLnk"
   !endif ;VISPA
   ${SelectSection} "${DelWinUpdate}" "Delete" "WinUpdate"
   !ifdef VISPA
     ${SelectSection} "${DelWelcomeCenter}" "Delete" "WelcomeCenter"
     ${SelectSection} "${DelWinMediaCenter}" "Delete" "WinMediaCenter"
     ${SelectSection} "${DelWinUltExtras}" "Delete" "WinUltExtras"
     ${SelectSection} "${DelWinMeetSpace}" "Delete" "WinMeetSpace"
   !endif ;VISPA
   !ifndef VISPA
     ${SelectSection} "${DelWinCatalog}" "Delete" "WinCatalog"
     ${SelectSection} "${DelProgAccess}" "Delete" "ProgAccess"
   !endif ;VISPA
   ${SelectSection} "${DelMsBookmarks}" "Delete" "MsBookmarks"
   ${SelectSection} "${DelSamplePictures}" "Delete" "SamplePictures"
   ${SelectSection} "${DelSampleMusic}" "Delete" "SampleMusic"
   !ifdef VISPA
     ${SelectSection} "${DelSampleVideos}" "Delete" "SampleVideos"
   !endif ;VISPA
   ${SelectSection} "${DelSamplePlaylists}" "Delete" "SamplePlaylists"
   ${SelectSection} "${DelBitmaps}" "Delete" "Bitmaps"
   ${SelectSection} "${DelPrefetch}" "Delete" "Prefetch"
   !ifdef VISPA
	${SelectSection} "${DelUpdCache}" "Delete" "UpdCache"
   !endif ;VISPA
FunctionEnd

!ifndef MINIXPY
Function UnSelectSections
;  unselect & hide all sections
   SectionSetText ${SecUnGeneral} "$(SubGeneral)"
   ${UnselectSection} "${SecGeneral}"
   SectionSetText ${SecGeneral} ""
   ${UnselectSection} "${GenCompressedFolders}"
   SectionSetText ${GenCompressedFolders} ""
   ${UnselectSection} "${GenRegWizC}"
   SectionSetText ${GenRegWizC} ""
   !ifndef VISPA
     ${UnselectSection} "${GenErrorRep}"
     SectionSetText ${GenErrorRep} ""
   !endif ;VISPA
   ${UnselectSection} "${GenLMHash}"
   SectionSetText ${GenLMHash} ""
   !ifndef VISPA
     ${UnselectSection} "${GenWGA}"
     SectionSetText ${GenWGA} ""
   !endif ;VISPA
   ${UnselectSection} "${GenScriptHost}"
   SectionSetText ${GenScriptHost} ""
   ${UnselectSection} "${GenRemAssist}"
   SectionSetText ${GenRemAssist} ""
   ${UnselectSection} "${GenRestrictAnon}"
   SectionSetText ${GenRestrictAnon} ""
   ${UnselectSection} "${GenInetOpen}"
   SectionSetText ${GenInetOpen} ""
   ${UnselectSection} "${GenNetCrawl}"
   SectionSetText ${GenNetCrawl} ""
   ${UnselectSection} "${GenHideComputer}"
   SectionSetText ${GenHideComputer} ""
   !ifndef VISPA
     ${UnselectSection} "${GenRepInfect}"
     SectionSetText ${GenRepInfect} ""
   !endif ;VISPA
   ${UnselectSection} "${GenMediaSense}"
   SectionSetText ${GenMediaSense} ""
   !ifndef VISPA
     ${UnselectSection} "${GenClaimWinReg}"
     SectionSetText ${GenClaimWinReg} ""
   !endif ;VISPA
   ${UnselectSection} "${GenPrefetch}"
   SectionSetText ${GenPrefetch} ""
   ${UnselectSection} "${GenFastShutdn}"
   SectionSetText ${GenFastShutdn} ""
   ${UnselectSection} "${GenDelPagefile}"
   SectionSetText ${GenDelPagefile} ""
   !ifndef VISPA
     ${UnselectSection} "${GenDelMRU}"
     SectionSetText ${GenDelMRU} ""
     ${UnselectSection} "${GenRecentShares}"
     SectionSetText ${GenRecentShares} ""
   !endif ;VISPA
   ${UnselectSection} "${GenLastUser}"
   SectionSetText ${GenLastUser} ""
   ${UnselectSection} "${GenPriorityCtrl}"
   SectionSetText ${GenPriorityCtrl} ""
   !ifdef VISPA
     ${UnselectSection} "${GenSysResponse}"
     SectionSetText ${GenSysResponse} ""
     ${UnselectSection} "${GenDisableUAC}"
     SectionSetText ${GenDisableUAC} ""
   !endif ;VISPA
   ${UnselectSection} "${GenRDPPort}"
   SectionSetText ${GenRDPPort} ""
   ${UnselectSection} "${GenSpyNet}"
   SectionSetText ${GenSpyNet} ""
   
   SectionSetText ${SecUnServices} "$(SubServices)"
   ${UnselectSection} "${SecServices}"
   SectionSetText ${SecServices} ""
   ${UnselectSection} "${ServErrorRep}"
   SectionSetText ${ServErrorRep} ""
   ${UnselectSection} "${ServAutoWinUpd}"
   SectionSetText ${ServAutoWinUpd} ""
   ${UnselectSection} "${ServSecCenter}"
   SectionSetText ${ServSecCenter} ""
   ${UnselectSection} "${ServWinDefend}"
   SectionSetText ${ServWinDefend} ""
   ${UnselectSection} "${ServTimeSync}"
   SectionSetText ${ServTimeSync} ""
   ${UnselectSection} "${ServSchedTask}"
   SectionSetText ${ServSchedTask} ""
   !ifndef VISPA
     ${UnselectSection} "${ServIndexing}"
     SectionSetText ${ServIndexing} ""
     ${UnselectSection} "${ServDCOM}"
     SectionSetText ${ServDCOM} ""
   !endif ;VISPA
   ${UnselectSection} "${ServTelnet}"
   SectionSetText ${ServTelnet} ""
   ${UnselectSection} "${ServUPnP}"
   SectionSetText ${ServUPnP} ""
   ${UnselectSection} "${ServUPnPDiscovery}"
   SectionSetText ${ServUPnPDiscovery} ""
   !ifndef VISPA
     ${UnselectSection} "${ServMessenger}"
     SectionSetText ${ServMessenger} ""
     ${UnselectSection} "${ServNetMeetingDesktop}"
     SectionSetText ${ServNetMeetingDesktop} ""
   !endif ;VISPA
   ${UnselectSection} "${ServRPCLoc}"
   SectionSetText ${ServRPCLoc} ""
   ${UnselectSection} "${ServRemReg}"
   SectionSetText ${ServRemReg} ""
   !ifndef VISPA
     ${UnselectSection} "${ServIcfIcs}"
     SectionSetText ${ServIcfIcs} ""
   !else ;VISPA
     ${UnselectSection} "${ServFirewall}"
     SectionSetText ${ServFirewall} ""
   !endif
   ${UnselectSection} "${ServImapi}"
   SectionSetText ${ServImapi} ""
   ${UnselectSection} "${ServAudioSrv}"
   SectionSetText ${ServAudioSrv} ""
   ${UnselectSection} "${ServWIA}"
   SectionSetText ${ServWIA} ""
   ${UnselectSection} "${TPAppleMobile}"
   SectionSetText ${TPAppleMobile} ""
   ${UnselectSection} "${TPIpodService}"
   SectionSetText ${TPIpodService} ""
   ${UnselectSection} "${TPGoogleUpdater}"
   SectionSetText ${TPGoogleUpdater} ""
   ${UnselectSection} "${TPGoogleSAC}"
   SectionSetText ${TPGoogleSAC} ""
   
   SectionSetText ${SecUnIExplore} "Internet Explorer"
   ${UnselectSection} "${SecIExplore}"
   SectionSetText ${SecIExplore} ""
   ${UnselectSection} "${IEAutoUpdates}"
   SectionSetText ${IEAutoUpdates} ""
   ${UnselectSection} "${IESchedUpd}"
   SectionSetText ${IESchedUpd} ""
   ${UnselectSection} "${IEErrorRep}"
   SectionSetText ${IEErrorRep} ""
   ${UnselectSection} "${IEIntWinAuth}"
   SectionSetText ${IEIntWinAuth} ""
   ${UnselectSection} "${IEMaxConn}"
   SectionSetText ${IEMaxConn} ""
   ${UnselectSection} "${IETabSettings}"
   SectionSetText ${IETabSettings} ""
   ${UnselectSection} "${IEuplddrvinfo}"
   SectionSetText ${IEuplddrvinfo} ""
   ${UnselectSection} "${IEDelTempFiles}"
   SectionSetText ${IEDelTempFiles} ""
   ${UnselectSection} "${IEWebformComplete}"
   SectionSetText ${IEWebformComplete} ""
   ${UnselectSection} "${IEPasswordComplete}"
   SectionSetText ${IEPasswordComplete} ""
   ${UnselectSection} "${IEAlexa}"
   SectionSetText ${IEAlexa} ""
   ${UnselectSection} "${IESearchPage}"
   SectionSetText ${IESearchPage} ""
   ${UnselectSection} "${IESearchScope}"
   SectionSetText ${IESearchScope} ""
   ${UnselectSection} "${IEActiveX}"
   SectionSetText ${IEActiveX} ""
   ${UnselectSection} "${IEJavaScript}"
   SectionSetText ${IEJavaScript} ""
   ${UnselectSection} "${IESSL2}"
   SectionSetText ${IESSL2} ""
   ${UnselectSection} "${IEPhishFilter}"
   SectionSetText ${IEPhishFilter} ""
   ${UnselectSection} "${IESearchAsst}"
   SectionSetText ${IESearchAsst} ""
   ${UnselectSection} "${IE404Search}"
   SectionSetText ${IE404Search} ""
   ${UnselectSection} "${IEBlankPage}"
   SectionSetText ${IEBlankPage} ""
   ${UnselectSection} "${IEDefaultPrompt}"
   SectionSetText ${IEDefaultPrompt} ""
   ${UnselectSection} "${IEInfoBar}"
   SectionSetText ${IEInfoBar} ""
   ${UnselectSection} "${IERemove}"
   SectionSetText ${IERemove} ""
   
   SectionSetText ${SecUnWMP} "Windows Media Player"
   ${UnselectSection} "${SecWMP}"
   SectionSetText ${SecWMP} ""
   ${UnselectSection} "${WMPAutoLicAcqu}"
   SectionSetText ${WMPAutoLicAcqu} ""
   !ifdef VISPA
     ${UnselectSection} "${WMPSilentDRM}"
     SectionSetText ${WMPSilentDRM} ""
   !endif ;VISPA
   !ifndef VISPA
     ${UnselectSection} "${WMPUpgradeMsg}"
     SectionSetText ${WMPUpgradeMsg} ""
   !endif ;VISPA
   ${UnselectSection} "${WMPLibrary}"
   SectionSetText ${WMPLibrary} ""
   ${UnselectSection} "${WMPMetadataRet}"
   SectionSetText ${WMPMetadataRet} ""
   ${UnselectSection} "${WMPUsageTrack}"
   SectionSetText ${WMPUsageTrack} ""
   !ifdef VISPA
     ${UnselectSection} "${WMPSendUID}"
     SectionSetText ${WMPSendUID} ""
   !endif ;VISPA
   !ifndef VISPA
     ${UnselectSection} "${WMPAutoUpdates}"
     SectionSetText ${WMPAutoUpdates} ""
     ${UnselectSection} "${WMPNoMRU}"
     SectionSetText ${WMPNoMRU} ""
   !endif ;VISPA
   ${UnselectSection} "${WMPAutoCodecDownl}"
   SectionSetText ${WMPAutoCodecDownl} ""
   ${UnselectSection} "${WMPImportMP3}"
   SectionSetText ${WMPImportMP3} ""
   ${UnselectSection} "${WMPImportMP3}"
   SectionSetText ${WMPNoDRM} ""
   ${UnselectSection} "${WMPNoDRM}"
   !ifndef VISPA
     SectionSetText ${WMPAllowDeinst} ""
     ${UnselectSection} "${WMPAllowDeinst}"
     SectionSetText ${SecUnWinMessenger} "Windows Messenger"
     ${UnselectSection} "${SecWinMessenger}"
     SectionSetText ${SecWinMessenger} ""
     ${UnselectSection} "${WMRemOE}"
     SectionSetText ${WMRemOE} ""
     ${UnselectSection} "${WMUninstall}"
     SectionSetText ${WMUninstall} ""
   !endif ;VISPA
   
   SectionSetText ${SecUnWinSearch} "$(TermWDS)"
   ${UnselectSection} "${SecWinSearch}"
   SectionSetText ${SecWinSearch} ""
   ${UnselectSection} "${WDSDisable}"
   SectionSetText ${WDSDisable} ""
   ${UnselectSection} "${WDSRemove}"
   SectionSetText ${WDSRemove} ""
   
   SectionSetText ${SecUnUsability} "$(SubUsability)"
   ${UnselectSection} "${SecUsability}"
   SectionSetText ${SecUsability} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabBalloonTips}"
     SectionSetText ${UsabBalloonTips} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabDiskSpace}"
   SectionSetText ${UsabDiskSpace} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabCmdHere}"
     SectionSetText ${UsabCmdHere} ""
     ${UnselectSection} "${UsabCmdCompl}"
     SectionSetText ${UsabCmdCompl} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabEditNotepad}"
   SectionSetText ${UsabEditNotepad} ""
   ${UnselectSection} "${UsabAutoRun}"
   SectionSetText ${UsabAutoRun} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabSearchAsst}"
     SectionSetText ${UsabSearchAsst} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabCleanupWiz}"
   SectionSetText ${UsabCleanupWiz} ""
   ${UnselectSection} "${UsabTaskGroup}"
   SectionSetText ${UsabTaskGroup} ""
   ${UnselectSection} "${UsabClassicStartMenu}"
   SectionSetText ${UsabClassicStartMenu} ""
   ${UnselectSection} "${UsabClassicLogon}"
   SectionSetText ${UsabClassicLogon} ""
   ${UnselectSection} "${UsabShutdownReason}"
   SectionSetText ${UsabShutdownReason} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabBarricade}"
     SectionSetText ${UsabBarricade} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabHiddenFiles}"
   SectionSetText ${UsabHiddenFiles} ""
   ${UnselectSection} "${UsabShowFileExt}"
   SectionSetText ${UsabShowFileExt} ""
   ${UnselectSection} "${UsabShowLNKExt}"
   SectionSetText ${UsabShowLNKExt} ""
   ${UnselectSection} "${UsabShowPIFExt}"
   SectionSetText ${UsabShowPIFExt} ""
   ${UnselectSection} "${UsabShowSCFExt}"
   SectionSetText ${UsabShowSCFExt} ""
   ${UnselectSection} "${UsabShowURLExt}"
   SectionSetText ${UsabShowURLExt} ""
   ${UnselectSection} "${UsabFullPath}"
   SectionSetText ${UsabFullPath} ""
   ${UnselectSection} "${UsabDisableThumbnails}"
   SectionSetText ${UsabDisableThumbnails} ""
   ${UnselectSection} "${UsabDisableSounds}"
   SectionSetText ${UsabDisableSounds} ""
   ${UnselectSection} "${UsabWinTheme}"
   SectionSetText ${UsabWinTheme} ""

   SectionSetText ${SecUnDelete} "$(SubDelete)"
   ${UnselectSection} "${SecDelete}"
   SectionSetText ${SecDelete} ""
   ${UnselectSection} "${DelIELnk}"
   SectionSetText ${DelIELnk} ""
   !ifndef VISPA
     ${UnselectSection} "${DelOutExLnk}"
     SectionSetText ${DelOutExLnk} ""
   !else ;VISPA
     ${UnselectSection} "${DelWinMail}"
     SectionSetText ${DelWinMail} ""
   !endif ;VISPA
   ${UnselectSection} "${DelRecycleBinLnk}"
   SectionSetText ${DelRecycleBinLnk} ""
   ${UnselectSection} "${DelMyDocumentsLnk}"
   SectionSetText ${DelMyDocumentsLnk} ""
   ${UnselectSection} "${DelMyComputerLnk}"
   SectionSetText ${DelMyComputerLnk} ""
   ${UnselectSection} "${DelMyNetworkLnk}"
   SectionSetText ${DelMyNetworkLnk} ""
   !ifdef VISPA
     ${UnselectSection} "${DelControlPanelLnk}"
     SectionSetText ${DelControlPanelLnk} ""
   !endif ;VISPA
   ${UnselectSection} "${DelWMPLnk}"
   SectionSetText ${DelWMPLnk} ""
   ${UnselectSection} "${DelMovieMkLnk}"
   SectionSetText ${DelMovieMkLnk} ""
   !ifdef VISPA
     ${UnselectSection} "${DelWinDVDMk}"
     SectionSetText ${DelWinDVDMk} ""
     ${UnselectSection} "${DelWinPhotoGal}"
     SectionSetText ${DelWinPhotoGal} ""
     ${UnselectSection} "${DelWinDefender}"
     SectionSetText ${DelWinDefender} ""
     ${UnselectSection} "${DelWinLiveDl}"
     SectionSetText ${DelWinLiveDl} ""
     ${UnselectSection} "${DelWinFaxScan}"
     SectionSetText ${DelWinFaxScan} ""
     ${UnselectSection} "${DelWinCalendar}"
     SectionSetText ${DelWinCalendar} ""
     ${UnselectSection} "${DelWinContacts}"
     SectionSetText ${DelWinContacts} ""
   !endif ;VISPA
   ${UnselectSection} "${DelMSNLnk}"
   SectionSetText ${DelMSNLnk} ""
   !ifndef VISPA
     ${UnselectSection} "${DelMessengerLnk}"
     SectionSetText ${DelMessengerLnk} ""
   !endif ;VISPA
   ${UnselectSection} "${DelWinUpdate}"
   SectionSetText ${DelWinUpdate} ""
   !ifdef VISPA
     ${UnselectSection} "${DelWelcomeCenter}"
     SectionSetText ${DelWelcomeCenter} ""
     ${UnselectSection} "${DelWinMediaCenter}"
     SectionSetText ${DelWinMediaCenter} ""
     ${UnselectSection} "${DelWinUltExtras}"
     SectionSetText ${DelWinUltExtras} ""
     ${UnselectSection} "${DelWinMeetSpace}"
     SectionSetText ${DelWinMeetSpace} ""
   !endif ;VISPA
  !ifndef VISPA
     ${UnselectSection} "${DelWinCatalog}"
     SectionSetText ${DelWinCatalog} ""
     ${UnselectSection} "${DelProgAccess}"
     SectionSetText ${DelProgAccess} ""
   !endif ;VISPA
   ${UnselectSection} "${DelMsBookmarks}"
   SectionSetText ${DelMsBookmarks} ""
   ${UnselectSection} "${DelSamplePictures}"
   SectionSetText ${DelSamplePictures} ""
   ${UnselectSection} "${DelSampleMusic}"
   SectionSetText ${DelSampleMusic} ""
   !ifdef VISPA
     ${UnselectSection} "${DelSampleVideos}"
     SectionSetText ${DelSampleVideos} ""
   !endif ;VISPA
   ${UnselectSection} "${DelSamplePlaylists}"
   SectionSetText ${DelSamplePlaylists} ""
   ${UnselectSection} "${DelBitmaps}"
   SectionSetText ${DelBitmaps} ""
   ${UnselectSection} "${DelPrefetch}"
   SectionSetText ${DelPrefetch} ""
   !ifdef VISPA
	   ${UnselectSection} "${DelUpdCache}"
	   SectionSetText ${DelUpdCache} ""
   !endif ;VISPA
FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
Function UnSelectUnSections
;  deselect & hide all unsections
   ${UnselectSection} "${SecUnGeneral}"
   SectionSetText ${SecUnGeneral} ""
   ${UnselectSection} "${GenUnCompressedFolders}"
   SectionSetText ${GenUnCompressedFolders} ""
   ${UnselectSection} "${GenUnRegWizC}"
   SectionSetText ${GenUnRegWizC} ""
   !ifndef VISPA
     ${UnselectSection} "${GenUnErrorRep}"
     SectionSetText ${GenUnErrorRep} ""
   !endif ;VISPA
   ${UnselectSection} "${GenUnLMHash}"
   SectionSetText ${GenUnLMHash} ""
   ${UnselectSection} "${GenUnScriptHost}"
   SectionSetText ${GenUnScriptHost} ""
   ${UnselectSection} "${GenUnRemAssist}"
   SectionSetText ${GenUnRemAssist} ""
   ${UnselectSection} "${GenUnInetOpen}"
   SectionSetText ${GenUnInetOpen} ""
   ${UnselectSection} "${GenUnRestrictAnon}"
   SectionSetText ${GenUnRestrictAnon} ""
   ${UnselectSection} "${GenUnNetCrawl}"
   SectionSetText ${GenUnNetCrawl} ""
   ${UnselectSection} "${GenUnHideComputer}"
   SectionSetText ${GenUnHideComputer} ""
   !ifndef VISPA
     ${UnselectSection} "${GenUnRepInfect}"
     SectionSetText ${GenUnRepInfect} ""
   !endif ;VISPA
   ${UnselectSection} "${GenUnMediaSense}"
   SectionSetText ${GenUnMediaSense} ""
   !ifndef VISPA
     ${UnselectSection} "${GenUnClaimWinReg}"
     SectionSetText ${GenUnClaimWinReg} ""
   !endif ;VISPA
   ${UnselectSection} "${GenUnPrefetch}"
   SectionSetText ${GenUnPrefetch} ""
   ${UnselectSection} "${GenUnFastShutdn}"
   SectionSetText ${GenUnFastShutdn} ""
   ${UnselectSection} "${GenUnDelPagefile}"
   SectionSetText ${GenUnDelPagefile} ""
   !ifndef VISPA
     ${UnselectSection} "${GenUnDelMRU}"
     SectionSetText ${GenUnDelMRU} ""
     ${UnselectSection} "${GenUnRecentShares}"
     SectionSetText ${GenUnRecentShares} ""
   !endif ;VISPA
   ${UnselectSection} "${GenUnLastUser}"
   SectionSetText ${GenUnLastUser} ""
   ${UnselectSection} "${GenUnPriorityCtrl}"
   SectionSetText ${GenUnPriorityCtrl} ""
   !ifdef VISPA
     ${UnselectSection} "${GenUnSysResponse}"
     SectionSetText ${GenUnSysResponse} ""
     ${UnselectSection} "${GenUnDisableUAC}"
     SectionSetText ${GenUnDisableUAC} ""
   !endif ;VISPA
   ${UnselectSection} "${GenUnRDPPort}"
   SectionSetText ${GenUnRDPPort} ""
   ${UnselectSection} "${GenUnSpyNet}"
   SectionSetText ${GenUnSpyNet} ""
   
   ${UnselectSection} "${SecUnServices}"
   SectionSetText ${SecUnServices} ""
   ${UnselectSection} "${ServUnErrorRep}"
   SectionSetText ${ServUnErrorRep} ""
   ${UnselectSection} "${ServUnAutoWinUpd}"
   SectionSetText ${ServUnAutoWinUpd} ""
   ${UnselectSection} "${ServUnSecCenter}"
   SectionSetText ${ServUnSecCenter} ""
   ${UnselectSection} "${ServUnWinDefend}"
   SectionSetText ${ServUnWinDefend} ""
   ${UnselectSection} "${ServUnTimeSync}"
   SectionSetText ${ServUnTimeSync} ""
   ${UnselectSection} "${ServUnSchedTask}"
   SectionSetText ${ServUnSchedTask} ""
   !ifndef VISPA
     ${UnselectSection} "${ServUnIndexing}"
     SectionSetText ${ServUnIndexing} ""
     ${UnselectSection} "${ServUnDCOM}"
     SectionSetText ${ServUnDCOM} ""
   !endif ;VISPA
   ${UnselectSection} "${ServUnTelnet}"
   SectionSetText ${ServUnTelnet} ""
   ${UnselectSection} "${ServUnUPnP}"
   SectionSetText ${ServUnUPnP} ""
   ${UnselectSection} "${ServUnUPnPDiscovery}"
   SectionSetText ${ServUnUPnpDiscovery} ""
   !ifndef VISPA
     ${UnselectSection} "${ServUnMessenger}"
     SectionSetText ${ServUnMessenger} ""
     ${UnselectSection} "${ServUnNetMeetingDesktop}"
     SectionSetText ${ServUnNetMeetingDesktop} ""
   !endif ;VISPA
   ${UnselectSection} "${ServUnRPCLoc}"
   SectionSetText ${ServUnRPCLoc} ""
   ${UnselectSection} "${ServUnRemReg}"
   SectionSetText ${ServUnRemReg} ""
   !ifndef VISPA
     ${UnselectSection} "${ServUnIcfIcs}"
     SectionSetText ${ServUnIcfIcs} ""
   !else ;VISPA
     ${UnselectSection} "${ServUnFirewall}"
     SectionSetText ${ServUnFirewall} ""
   !endif ;VISPA
   ${UnselectSection} "${ServUnImapi}"
   SectionSetText ${ServUnImapi} ""
   ${UnselectSection} "${ServUnAudioSrv}"
   SectionSetText ${ServUnAudioSrv} ""
   ${UnselectSection} "${ServUnWIA}"
   SectionSetText ${ServUnWIA} ""
   
   ${UnselectSection} "${SecUnIExplore}"
   SectionSetText ${SecUnIExplore} ""
   ${UnselectSection} "${IEUnAutoUpdates}"
   SectionSetText ${IEUnAutoUpdates} ""
   ${UnselectSection} "${IEUnSchedUpd}"
   SectionSetText ${IEUnSchedUpd} ""
   ${UnselectSection} "${IEUnErrorRep}"
   SectionSetText ${IEUnErrorRep} ""
   ${UnselectSection} "${IEUnIntWinAuth}"
   SectionSetText ${IEUnIntWinAuth} ""
   ${UnselectSection} "${IEUnMaxConn}"
   SectionSetText ${IEUnMaxConn} ""
   ${UnselectSection} "${IEUnTabSettings}"
   SectionSetText ${IEUnTabSettings} ""
   ${UnselectSection} "${IEUnDelTempFiles}"
   SectionSetText ${IEUnDelTempFiles} ""
   ${UnselectSection} "${IEUnWebformComplete}"
   SectionSetText ${IEUnWebformComplete} ""
   ${UnselectSection} "${IEUnPasswordComplete}"
   SectionSetText ${IEUnPasswordComplete} ""
   ${UnselectSection} "${IEUnSearchPage}"
   SectionSetText ${IEUnSearchPage} ""
   ${UnselectSection} "${IEUnSearchScope}"
   SectionSetText ${IEUnSearchScope} ""
   ${UnselectSection} "${IEUnActiveX}"
   SectionSetText ${IEUnActiveX} ""
   ${UnselectSection} "${IEUnJavaScript}"
   SectionSetText ${IEUnJavaScript} ""
   ${UnselectSection} "${IEUnSSL2}"
   SectionSetText ${IEUnSSL2} ""
   ${UnselectSection} "${IEUnPhishFilter}"
   SectionSetText ${IEUnPhishFilter} ""
   ${UnselectSection} "${IEUnSearchAsst}"
   SectionSetText ${IEUnSearchAsst} ""
   ${UnselectSection} "${IEUn404Search}"
   SectionSetText ${IEUn404Search} ""
   ${UnselectSection} "${IEUnBlankPage}"
   SectionSetText ${IEUnBlankPage} ""
   ${UnselectSection} "${IEUnDefaultPrompt}"
   SectionSetText ${IEUnDefaultPrompt} ""
   ${UnselectSection} "${IEUnInfoBar}"
   SectionSetText ${IEUnInfoBar} ""
   
   ${UnselectSection} "${SecUnWMP}"
   SectionSetText ${SecUnWMP} ""
   ${UnselectSection} "${WMPUnAutoLicAcqu}"
   SectionSetText ${WMPUnAutoLicAcqu} ""
   !ifdef VISPA
     ${UnselectSection} "${WMPUnSilentDRM}"
     SectionSetText ${WMPUnSilentDRM} ""
   !endif ;VISPA
   !ifndef VISPA
     ${UnselectSection} "${WMPUnUpgradeMsg}"
     SectionSetText ${WMPUnUpgradeMsg} ""
   !endif ;VISPA
   ${UnselectSection} "${WMPUnLibrary}"
   SectionSetText ${WMPUnLibrary} ""
   ${UnselectSection} "${WMPUnMetadataRet}"
   SectionSetText ${WMPUnMetadataRet} ""
   ${UnselectSection} "${WMPUnUsageTrack}"
   SectionSetText ${WMPUnUsageTrack} ""
   !ifdef VISPA
     ${UnselectSection} "${WMPUnSendUID}"
     SectionSetText ${WMPUnSendUID} ""
   !endif ;VISPA
   !ifndef VISPA
     ${UnselectSection} "${WMPUnAutoUpdates}"
     SectionSetText ${WMPUnAutoUpdates} ""
     ${UnselectSection} "${WMPUnNoMRU}"
     SectionSetText ${WMPUnNoMRU} ""
   !endif ;VISPA
   ${UnselectSection} "${WMPUnAutoCodecDownl}"
   SectionSetText ${WMPUnAutoCodecDownl} ""
   ${UnselectSection} "${WMPUnImportMP3}"
   SectionSetText ${WMPUnImportMP3} ""
   ${UnselectSection} "${WMPUnNoDRM}"
   SectionSetText ${WMPUnNoDRM} ""
   !ifndef VISPA
     ${UnselectSection} "${WMPUnAllowDeinst}"
     SectionSetText ${WMPUnAllowDeinst} ""
     ${UnselectSection} "${SecUnWinMessenger}"
     SectionSetText ${SecUnWinMessenger} ""
     ${UnselectSection} "${WMUnRemOE}"
     SectionSetText ${WMUnRemOE} ""
   !endif ;VISPA
   
   ${UnselectSection} "${SecUnWinSearch}"
   SectionSetText ${SecUnWinSearch} ""
   ${UnselectSection} "${WDSUnDisable}"
   SectionSetText ${WDSUnDisable} ""
   
   ${UnselectSection} "${SecUnUsability}"
   SectionSetText ${SecUnUsability} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabUnBalloonTips}"
     SectionSetText ${UsabUnBalloonTips} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabUnDiskSpace}"
   SectionSetText ${UsabUnDiskSpace} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabUnCmdHere}"
     SectionSetText ${UsabUnCmdHere} ""
     ${UnselectSection} "${UsabUnCmdCompl}"
     SectionSetText ${UsabUnCmdCompl} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabUnEditNotepad}"
   SectionSetText ${UsabUnEditNotepad} ""
   ${UnselectSection} "${UsabUnAutoRun}"
   SectionSetText ${UsabUnAutoRun} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabUnSearchAsst}"
     SectionSetText ${UsabUnSearchAsst} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabUnCleanupWiz}"
   SectionSetText ${UsabUnCleanupWiz} ""
   ${UnselectSection} "${UsabUnTaskGroup}"
   SectionSetText ${UsabUnTaskGroup} ""
   ${UnselectSection} "${UsabUnClassicStartMenu}"
   SectionSetText ${UsabUnClassicStartMenu} ""
   ${UnselectSection} "${UsabUnClassicLogon}"
   SectionSetText ${UsabUnClassicLogon} ""
   ${UnselectSection} "${UsabUnShutdownReason}"
   SectionSetText ${UsabUnShutdownReason} ""
   !ifndef VISPA
     ${UnselectSection} "${UsabUnBarricade}"
     SectionSetText ${UsabUnBarricade} ""
   !endif ;VISPA
   ${UnselectSection} "${UsabUnHiddenFiles}"
   SectionSetText ${UsabUnHiddenFiles} ""
   ${UnselectSection} "${UsabUnShowFileExt}"
   SectionSetText ${UsabUnShowFileExt} ""
   ${UnselectSection} "${UsabUnShowLNKExt}"
   SectionSetText ${UsabUnShowLNKExt} ""
   ${UnselectSection} "${UsabUnShowPIFExt}"
   SectionSetText ${UsabUnShowPIFExt} ""
   ${UnselectSection} "${UsabUnShowSCFExt}"
   SectionSetText ${UsabUnShowSCFExt} ""
   ${UnselectSection} "${UsabUnShowURLExt}"
   SectionSetText ${UsabUnShowURLExt} ""
   ${UnselectSection} "${UsabUnFullPath}"
   SectionSetText ${UsabUnFullPath} ""
   ${UnselectSection} "${UsabUnDisableThumbnails}"
   SectionSetText ${UsabUnDisableThumbnails} ""
   ${UnselectSection} "${UsabUnDisableSounds}"
   SectionSetText ${UsabUnDisableSounds} ""
   ${UnselectSection} "${UsabUnWinTheme}"
   SectionSetText ${UsabUnWinTheme} ""
   
   ${UnselectSection} "${TPUnAppleMobile}"
   SectionSetText ${TPUnAppleMobile} ""
   ${UnselectSection} "${TPUnIpodService}"
   SectionSetText ${TPUnIpodService} ""
   ${UnselectSection} "${TPUnGoogleUpdater}"
   SectionSetText ${TPUnGoogleUpdater} ""
   ${UnselectSection} "${TPUnGoogleSAC}"
   SectionSetText ${TPUnGoogleSAC} ""
   
   ${UnselectSection} "${SecUnDelete}"
   SectionSetText ${SecUnDelete} ""
   ${UnselectSection} "${DelUnIELnk}"
   SectionSetText ${DelUnIELnk} ""
   !ifndef VISPA
     ${UnselectSection} "${DelUnOutExLnk}"
     SectionSetText ${DelUnOutExLnk} ""
   !else ;VISPA
     ${UnselectSection} "${DelUnWinMail}"
     SectionSetText ${DelUnWinMail} ""
   !endif ;VISPA
   ${UnselectSection} "${DelUnRecycleBin}"
   SectionSetText ${DelUnRecycleBin} ""
   ${UnselectSection} "${DelUnMyDocuments}"
   SectionSetText ${DelUnMyDocuments} ""
   ${UnselectSection} "${DelUnMyComputer}"
   SectionSetText ${DelUnMyComputer} ""
   ${UnselectSection} "${DelUnMyNetwork}"
   SectionSetText ${DelUnMyNetwork} ""
   !ifdef VISPA
     ${UnselectSection} "${DelUnControlPanel}"
     SectionSetText ${DelUnControlPanel} ""
   !endif ;VISPA
   ${UnselectSection} "${DelUnWMPLnk}"
   SectionSetText ${DelUnWMPLnk} ""
   ${UnselectSection} "${DelUnMovieMkLnk}"
   SectionSetText ${DelUnMovieMkLnk} ""
   !ifdef VISPA
     ${UnselectSection} "${DelUnWinDVDMk}"
     SectionSetText ${DelUnWinDVDMk} ""
     ${UnselectSection} "${DelUnWinPhotoGal}"
     SectionSetText ${DelUnWinPhotoGal} ""
     ${UnselectSection} "${DelUnWinDefender}"
     SectionSetText ${DelUnWinDefender} ""
     ${UnselectSection} "${DelUnWinFaxScan}"
     SectionSetText ${DelUnWinFaxScan} ""
     ${UnselectSection} "${DelUnWinCalendar}"
     SectionSetText ${DelUnWinCalendar} ""
     ${UnselectSection} "${DelUnWinContacts}"
     SectionSetText ${DelUnWinContacts} ""
   !endif ;VISPA
   ${UnselectSection} "${DelUnMSNLnk}"
   SectionSetText ${DelUnMSNLnk} ""
   !ifndef VISPA
     ${UnselectSection} "${DelUnMessengerLnk}"
     SectionSetText ${DelUnMessengerLnk} ""
   !endif ;VISPA
   ${UnselectSection} "${DelUnWinUpdate}"
   SectionSetText ${DelUnWinUpdate} ""
   !ifdef VISPA
     ${UnselectSection} "${DelUnWinMediaCenter}"
     SectionSetText ${DelUnWinMediaCenter} ""
     ${UnselectSection} "${DelUnWinMeetSpace}"
     SectionSetText ${DelUnWinMeetSpace} ""
   !endif ;VISPA
FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
 Function AutoDetect
; detects unnecessary settings and locks them
  ${If} $Output == ""
  ${AndIfNot} $Force == "1"
   ReadRegStr $0 HKCR ".zip" ""
   StrCmp $0 "CompressedFolder" +4 0
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${GenCompressedFolders} $1
   SectionSetInstTypes ${GenCompressedFolders} ${ALLSECTIONS}

   ReadRegStr $0 HKCR "RegWizCtrl.RegWizCtrl" ""
   StrCmp $0 "RegWizCtrl " +4 0
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${GenRegWizC} $1
   SectionSetInstTypes ${GenRegWizC} ${ALLSECTIONS}
   
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\PCHealth\ErrorReporting" "DoReport" "0" "${GenErrorRep}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\Lsa" "nolmhash" "1" "${GenLMHash}"

   !ifndef VISPA
     StrCpy $0 "0"
     ClearErrors
     EnumRegValue $2 "HKLM" "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon\Notify\WGALogon" $0
     IfErrors 0 +4
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${GenWGA} $1
     SectionSetInstTypes ${GenWGA} ${ALLSECTIONS}
   !endif ;VISPA

   ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\Windows Script Host\Settings" "Enabled" "0" "${GenScriptHost}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\Terminal Server" "fDenyTSConnections" "1" "${GenRemAssist}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\Lsa" "restrictanonymous" "1" "${GenRestrictAnon}"
   ${Reload} "Dword" "HKCU" "SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer" "InternetOpenWith" "0" "${GenInetOpen}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "NoNetCrawling" "1" "${GenNetCrawl}"
   ${Reload} "Dword" "HKLM" "SYSTEM\ControlSet001\Services\lanmanserver\parameters" "hidden" "1" "${GenHideComputer}"
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SOFTWARE\Policies\Microsoft\MRT" "DontReportInfectionInformation" "1" "${GenRepInfect}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\Tcpip\Parameters" "DisableDHCPMediaSense" "1" "${GenMediaSense}"
   !ifndef VISPA
     ${Reload} "Str" "HKLM" "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "RegDone" "1" "${GenClaimWinReg}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\Session Manager\Memory Management\PrefetchParameters" "EnablePrefetcher" "2" "${GenPrefetch}"
   ${Reload} "Str" "HKCU" "Control Panel\Desktop" "AutoEndTasks" "1" "${GenFastShutdn}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\Session Manager\Memory Management" "ClearPageFileAtShutdown" "1" "${GenDelPagefile}"
   !ifndef VISPA
     ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "ClearRecentDocsOnExit" "1" "${GenDelMRU}"
     ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "NoRecentDocsNetHood" "1" "${GenRecentShares}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System" "DontDisplayLastUserName" "1" "${GenLastUser}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\PriorityControl" "Win32PrioritySeparation" "26" "${GenPriorityCtrl}"
   !ifdef VISPA
     ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Multimedia\SystemProfile" "SystemResponsiveness" "20" "${GenSysResponse}"
     ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System" "EnableLUA" "0" "${GenDisableUAC}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Control\Terminal Server\WinStations\RDP-Tcp" "PortNumber" "3389" "${GenRDPPort}"
   ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\Microsoft Antimalware\SpyNet" "SpyNetReporting" "0" "${GenSpyNet}"
   

   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "System\CurrentControlSet\Services\ERSvc" "Start" "4" "${ServErrorRep}"
   !else ;VISPA
     ${Reload} "Dword" "HKLM" "System\CurrentControlSet\Services\WerSvc" "Start" "4" "${ServErrorRep}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\wuauserv" "Start" "4" "${ServAutoWinUpd}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\wscsvc" "Start" "4" "${ServSecCenter}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\WinDefend" "Start" "4" "${ServWinDefend}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\W32Time" "Start" "4" "${ServTimeSync}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\Schedule" "Start" "4" "${ServSchedTask}"
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\CiSvc" "Start" "4" "${ServIndexing}"

     ReadRegDWORD $0 "HKLM" "SOFTWARE\Microsoft\Ole" "EnableDCOM"
     ${IfNot} $0 == "0"
     ${OrIfNot} $0 == "N"
     	   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   	   SectionSetFlags ${ServDCOM} $1
   	   SectionSetInstTypes ${ServDCOM} ${ALLSECTIONS}
     ${EndIf}
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\TlntSvr" "Start" "4" "${ServTelnet}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\upnphost" "Start" "4" "${ServUPnP}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\SSDPSRV" "Start" "4" "${ServUPnPDiscovery}"
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\Messenger" "Start" "4" "${ServMessenger}"
     ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\mnmsrvc" "Start" "4" "${ServNetMeetingDesktop}"
   !endif ;VISPA
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\RpcLocator" "Start" "4" "${ServRPCLoc}"
   ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\RemoteRegistry" "Start" "4" "${ServRemReg}"
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\SharedAccess" "Start" "4" "${ServIcfIcs}"
   !else ;VISPA
     ${Reload} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\MpsSvc" "Start" "4" "${ServFirewall}"
   !endif ;VISPA
   ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\ImapiService" "Start" "2" "3" "${ServImapi}"
   ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\AudioSrv" "Start" "2" "3" "${ServAudioSrv}"
   ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\stisvc" "Start" "2" "3" "${ServWIA}"
   ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\Apple Mobile Device" "Start" "" "4" "${TPAppleMobile}"
   ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\iPod Service" "Start" "" "4" "${TPIpodService}"
   ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\gusvc" "Start" "" "4" "${TPGoogleUpdater}"
   ${ReloadOr} "Dword" "HKLM" "SOFTWARE\Policies\Google\Google Desktop\Enterprise" "disallow_ssd_service" "" "1" "${TPGoogleSAC}"

   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "NoUpdateCheck" "1" "${IEAutoUpdates}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Webcheck" "NoScheduledUpdates" "1" "${IESchedUpd}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "IEWatsonDisabled" "1" "${IEErrorRep}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Internet Settings" "EnableNegotiate" "0" "${IEIntWinAuth}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Internet Settings" "MaxConnectionsPerServer" "32" "${IEMaxConn}"

   ReadRegStr $0 "HKLM" "SOFTWARE\Microsoft\Internet Explorer" "Version"
   StrCpy $IeVersion $0 1
   IntCmp $IeVersion "7" 0 NoIE7TabSettings 0
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\TabbedBrowsing" "PopupsUseNewWindow" "2" "${IETabSettings}"
   Goto PostTabSettings
   NoIE7TabSettings:
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IETabSettings} $1
   SectionSetInstTypes ${IETabSettings} ${ALLSECTIONS}
   PostTabSettings:

   IfFileExists "$WINDIR\pchealth\helpctr\System\DFS\uplddrvinfo.htm" +4 0
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IEuplddrvinfo} $1
   SectionSetInstTypes ${IEuplddrvinfo} ${ALLSECTIONS}
   
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Internet Settings\Cache" "Persistent" "0" "${IEDelTempFiles}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "Use FormSuggest" "no" "${IEWebformComplete}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "FormSuggest Passwords" "no" "${IEPasswordComplete}"

   ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Internet Explorer\Extensions\{c95fe080-8f5d-11d2-a20b-00aa003c157a}" ""
   StrCmp $0 "" 0 +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IEAlexa} $1
   SectionSetInstTypes ${IEAlexa} ${ALLSECTIONS}

   ReadRegStr $0 HKCU "Software\Microsoft\Internet Explorer\Main" "Search Page"
   StrCmp $0 "http://www.microsoft.com/isapi/redir.dll?prd=ie&ar=iesearch" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IESearchPage} $1
   SectionSetInstTypes ${IESearchPage} ${ALLSECTIONS}

   ReadRegStr $0 HKCU "Software\Microsoft\Internet Explorer\SearchScopes" "DefaultScope"
   ReadRegStr $1 HKCU "Software\Microsoft\Internet Explorer\SearchScopes\$0" ""
   StrCmp $1 "Live Search" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IESearchScope} $1
   SectionSetInstTypes ${IESearchScope} ${ALLSECTIONS}

   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Internet Settings\Zones\3" "1200" "3" "${IEActiveX}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Internet Settings\Zones\3" "1400" "3" "${IEJavaScript}"

   ReadRegDWORD $0 "HKCU" "Software\Microsoft\Windows\CurrentVersion\Internet Settings" "SecureProtocols"
   StrCmp $0 "" 0 +2
   StrCpy $0 "40"
   StrCmp $0 "8" PostSSL2
   StrCmp $0 "40" PostSSL2
   StrCmp $0 "136" PostSSL2
   StrCmp $0 "168" PostSSL2 0
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IESSL2} $1
   SectionSetInstTypes ${IESSL2} ${ALLSECTIONS}
  PostSSL2:

   IntCmp $IeVersion "7" 0 NoIE7PhishFilter 0
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\PhishingFilter" "Enabled" "0" "${IEPhishFilter}"
   Goto PostPhishFilter
   NoIE7PhishFilter:
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IEPhishFilter} $1
   SectionSetInstTypes ${IEPhishFilter} ${ALLSECTIONS}
   PostPhishFilter:

   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "Use Search Asst" "no" "${IESearchAsst}"
   ${Reload} "Str" "HKCU" "Software\Microsoft\Internet Explorer\Main" "Do404Search" "01000000" "${IE404Search}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "Start Page" "about:blank" "${IEBlankPage}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\Main" "Check_Associations" "no" "${IEDefaultPrompt}"

   IntCmp $IeVersion "7" 0 NoIE7InfoBar 0
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Internet Explorer\InformationBar" "FirstTime" "0" "${IEInfoBar}"
   Goto PostInfoBar
   NoIE7InfoBar:
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${IEInfoBar} $1
   SectionSetInstTypes ${IEInfoBar} ${ALLSECTIONS}
   PostInfoBar:
   
   IntCmp $IeVersion "7" 0 NoIERemove 0
   ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ie$IeVersion" "UninstallString"
   ${If} $0 == ""
     NoIERemove:
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${IERemove} $1
     SectionSetInstTypes ${IERemove} ${ALLSECTIONS}
   ${EndIf}

   ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "SilentAcquisition" "0" "${WMPAutoLicAcqu}"
   !ifdef VISPA
     ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "SilentDRMConfiguration" "0" "${WMPSilentDRM}"
   !endif ;VISPA
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\MediaPlayer\PlayerUpgrade" "AskMeAgain" "no" "${WMPUpgradeMsg}"
   !endif ;VISPA
   ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "AutoAddMusicToLibrary" "0" "${WMPLibrary}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "MetadataRetrieval" "0" "${WMPMetadataRet}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "UsageTracking" "0" "${WMPUsageTrack}"
   !ifdef VISPA
     ${Reload} "Dword"  "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "SendUserGUID" "00" "${WMPSendUID}"
   !endif ;VISPA
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SOFTWARE\Policies\Microsoft\WindowsMediaPlayer" "disableAutoUpdate" "1" "${WMPAutoUpdates}"
     ${Reload} "Dword" "HKLM" "SOFTWARE\Policies\Microsoft\WindowsMediaPlayer" "disableMRU" "1" "${WMPNoMRU}"
   !endif ;VISPA
   ${Reload} "Dword" "HKCU" "Software\Policies\Microsoft\Preferences" "UpgradeCodecPrompt" "0" "${WMPAutoCodecDownl}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "CDRecordMP3" "1" "${WMPImportMP3}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\MediaPlayer\Preferences" "CDRecordDRM" "0" "${WMPNoDRM}"
   !ifndef VISPA
     ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\MediaPlayer" "BlockUninstall" "no" "${WMPAllowDeinst}"
     ${Reload} "Dword" "HKLM" "SOFTWARE\Microsoft\Outlook Express" "Hide Messenger" "2" "${WMRemOE}"
     ${ReloadOr} "Dword" "HKLM" "SYSTEM\CurrentControlSet\Services\WSearch" "Start" "" "4" ${WMUninstall}
   !endif ;VISPA

   ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\KB940157" "UninstallString"
   ${If} $0 == ""
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${WDSRemove} $1
     SectionSetInstTypes ${WDSRemove} ${ALLSECTIONS}
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${WDSDisable} $1
     SectionSetInstTypes ${WDSDisable} ${ALLSECTIONS}
   ${EndIf}

   StrCmp $0 "" 0 +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${WDSRemove} $1
   SectionSetInstTypes ${WDSRemove} ${ALLSECTIONS}
   
   !ifndef VISPA
     ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "EnableBalloonTips" "0" "${UsabBalloonTips}"
   !endif ;VISPA

   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "NoLowDiskSpaceChecks" "1" "${UsabDiskSpace}"

   !ifndef VISPA
     ReadRegStr $0 HKCR "Drive\shell\cmd" ""
     StrCmp $0 "Open Command Window Here" 0 +4
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${UsabCmdHere} $1
     SectionSetInstTypes ${UsabCmdHere} ${ALLSECTIONS}
     
     ${Reload} "Dword" "HKCU" "Software\Microsoft\Command Processor" "CompletionChar" "9" "${UsabCmdCompl}"
   !endif ;VISPA

   ReadRegStr $0 HKCR "*\shell\edit" ""
   StrCmp $0 "$(LabelEdit)" 0 +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${UsabEditNotepad} $1
   SectionSetInstTypes ${UsabEditNotepad} ${ALLSECTIONS}

   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "NoDriveTypeAutoRun" "67108863" "${UsabAutoRun}"
   !ifndef VISPA
     ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\CabinetState" "Use Search Asst" "no" "${UsabSearchAsst}"
   !endif ;VISPA
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Desktop\CleanupWiz" "NoRun" "1" "${UsabCleanupWiz}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "TaskbarGlomming" "0" "${UsabTaskGroup}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "NoSimpleStartMenu" "1" "${UsabClassicStartMenu}"
   ${Reload} "Dword" "HKLM" "Software\Microsoft\Windows NT\CurrentVersion\Winlogon" "ClassicLogon" "0" "${UsabClassicLogon}"
   ${If} ${IsWin2003}
		${Reload} "Dword" "HKLM" "SOFTWARE\Policies\Microsoft\Windows NT\Reliability" "ShutdownReasonOn" "0" "${UsabShutdownReason}"
   ${Else}
	    IntOp $1 ${SF_SELECTED} | ${SF_RO}
	    SectionSetFlags ${UsabShutdownReason} $1
	    SectionSetInstTypes ${UsabShutdownReason} ${ALLSECTIONS}
	${EndIf}
   !ifndef VISPA
     ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\WebView\BarricadedFolders" "shell:SystemDriveRootFolder" "0" "${UsabBarricade}"
   !endif ;VISPA
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "Hidden" "1" "${UsabHiddenFiles}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "HideFileExt" "0" "${UsabShowFileExt}"
   
   ${IfNot} $Output >= "1"
	    ClearErrors
		ReadRegStr $0 "HKCR" "lnkfile" "NeverShowExt"
	    IfErrors 0 +6
	    Push $1
	    IntOp $1 ${SF_SELECTED} | ${SF_RO}
	    SectionSetFlags ${UsabShowLNKExt} $1
	    Pop $1
	    SectionSetInstTypes ${UsabShowLNKExt} ${ALLSECTIONS}
   ${EndIf}
   
   ${IfNot} $Output >= "1"
	    ClearErrors
		ReadRegStr $0 "HKCR" "piffile" "NeverShowExt"
	    IfErrors 0 +6
	    Push $1
	    IntOp $1 ${SF_SELECTED} | ${SF_RO}
	    SectionSetFlags ${UsabShowPIFExt} $1
	    Pop $1
	    SectionSetInstTypes ${UsabShowPIFExt} ${ALLSECTIONS}
   ${EndIf}
   
   ${IfNot} $Output >= "1"
	    ClearErrors
		ReadRegStr $0 "HKCR" "SHCmdFile" "NeverShowExt"
	    IfErrors 0 +6
	    Push $1
	    IntOp $1 ${SF_SELECTED} | ${SF_RO}
	    SectionSetFlags ${UsabShowSCFExt} $1
	    Pop $1
	    SectionSetInstTypes ${UsabShowSCFExt} ${ALLSECTIONS}
   ${EndIf}
   
   ${IfNot} $Output >= "1"
	    ClearErrors
		ReadRegStr $0 "HKCR" "InternetShortcut" "NeverShowExt"
	    IfErrors 0 +6
	    Push $1
	    IntOp $1 ${SF_SELECTED} | ${SF_RO}
	    SectionSetFlags ${UsabShowURLExt} $1
	    Pop $1
	    SectionSetInstTypes ${UsabShowURLExt} ${ALLSECTIONS}
   ${EndIf}
   
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\CabinetState" "FullPath" "1" "${UsabFullPath}"
   ${Reload} "Dword" "HKCU" "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "DisableThumbnailCache" "1" "${UsabDisableThumbnails}"

#   ${Reload} "Str" "HKCU" "AppEvents\Schemes\Apps\.Default\SystemStart\.current" "" "" "${UsabDisableSounds}"
   ReadRegStr $0 HKCU "AppEvents\Schemes\Apps\.Default\SystemStart\.current" ""
   ${If} $0 == ""
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${UsabDisableSounds} $1
     SectionSetInstTypes ${UsabDisableSounds} ${ALLSECTIONS}
   ${EndIf}

   ${Reload} "Dword" "HKCU" "Software\Microsoft\Plus!\Themes\Current" "" "%SystemRoot%\resources\Themes\Windows Classic.theme" "${UsabWinTheme}"
   
   ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{871C5380-42A0-1069-A2EA-08002B30309D}"
   ${If} $0 == "1"
   !ifndef VISPA
   ${OrIfNot} ${FileExists} "$SMPROGRAMS\Internet Explorer.lnk"
   !endif ;VISPA
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${DelIELnk} $1
     SectionSetInstTypes ${DelIELnk} ${ALLSECTIONS}
   ${EndIf}

 !ifndef VISPA
   IfFileExists "$SMPROGRAMS\Outlook Express.lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelOutExLnk} $1
   SectionSetInstTypes ${DelOutExLnk} ${ALLSECTIONS}
 !else ;VISPA
   IfFileExists "$SMPROGRAMS\Windows Mail.lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinMail} $1
   SectionSetInstTypes ${DelWinMail} ${ALLSECTIONS}
 !endif ;VISPA

   ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{645FF040-5081-101B-9F08-00AA002F954E}"
   ${If} $0 == "1"
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${DelRecycleBinLnk} $1
     SectionSetInstTypes ${DelRecycleBinLnk} ${ALLSECTIONS}
   ${EndIf}
   
   !ifndef VISPA
     ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{450D8FBA-AD25-11D0-98A8-0800361B1103}"
	 ReadRegDWORD $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\NewStartPanel" "{450D8FBA-AD25-11D0-98A8-0800361B1103}"
   !else ;VISPA
     ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{59031a47-3f72-44a7-89c5-5595fe6b30ee}"
	 ReadRegDWORD $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\NewStartPanel" "{59031a47-3f72-44a7-89c5-5595fe6b30ee}"
   !endif ;VISPA
   ${If} $0 == "1"
   ${OrIf} $1 == "1"
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${DelMyDocumentsLnk} $1
     SectionSetInstTypes ${DelMyDocumentsLnk} ${ALLSECTIONS}
   ${EndIf}
   
   ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{20D04FE0-3AEA-1069-A2D8-08002B30309D}"
   ReadRegDWORD $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\NewStartPanel" "{20D04FE0-3AEA-1069-A2D8-08002B30309D}"
   ${If} $0 == "1"
   ${OrIf} $1 == "1"
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${DelMyComputerLnk} $1
     SectionSetInstTypes ${DelMyComputerLnk} ${ALLSECTIONS}
   ${EndIf}
   
   !ifndef VISPA
     ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{208D2C60-3AEA-1069-A2D7-08002B30309D}"
	 ReadRegDWORD $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\NewStartPanel" "{208D2C60-3AEA-1069-A2D7-08002B30309D}"
   !else ;VISPA
     ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{F02C1A0D-BE21-4350-88B0-7367FC96EF3C}"
	 ReadRegDWORD $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\NewStartPanel" "{F02C1A0D-BE21-4350-88B0-7367FC96EF3C}"
   !endif ;VISPA
   ${If} $0 == "1"
   ${OrIf} $1 == "1"
     IntOp $1 ${SF_SELECTED} | ${SF_RO}
     SectionSetFlags ${DelMyNetworkLnk} $1
     SectionSetInstTypes ${DelMyNetworkLnk} ${ALLSECTIONS}
   ${EndIf}
   
   !ifdef VISPA
     ReadRegDWORD $0 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\ClassicStartMenu" "{5399E694-6CE5-4D6C-8FCE-1D8870FDCBA0}"
	 ReadRegDWORD $1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\HideDesktopIcons\NewStartPanel" "{5399E694-6CE5-4D6C-8FCE-1D8870FDCBA0}"
	 ${If} $0 == "1"
	 ${OrIf} $1 == "1"
       IntOp $1 ${SF_SELECTED} | ${SF_RO}
       SectionSetFlags ${DelControlPanelLnk} $1
       SectionSetInstTypes ${DelControlPanelLnk} ${ALLSECTIONS}
     ${EndIf}
   !endif ;VISPA

   IfFileExists "$SMPROGRAMS\Windows Media Player.lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWMPLnk} $1
   SectionSetInstTypes ${DelWMPLnk} ${ALLSECTIONS}

   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinMovieMk).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelMovieMkLnk} $1
   SectionSetInstTypes ${DelMovieMkLnk} ${ALLSECTIONS}
#   SetShellVarContext current
   
!ifdef VISPA
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinDVDMk).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinDVDMk} $1
   SectionSetInstTypes ${DelWinDVDMk} ${ALLSECTIONS}
#   SetShellVarContext current
   
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinPhotoGal).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinPhotoGal} $1
   SectionSetInstTypes ${DelWinPhotoGal} ${ALLSECTIONS}
#   SetShellVarContext current
   
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinDefender).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinDefender} $1
   SectionSetInstTypes ${DelWinDefender} ${ALLSECTIONS}
#   SetShellVarContext current
   
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinLiveDl).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinLiveDl} $1
   SectionSetInstTypes ${DelWinLiveDl} ${ALLSECTIONS}
#   SetShellVarContext current
   
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinFaxScan).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinFaxScan} $1
   SectionSetInstTypes ${DelWinFaxScan} ${ALLSECTIONS}
#   SetShellVarContext current

#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinCalendar).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinCalendar} $1
   SectionSetInstTypes ${DelWinCalendar} ${ALLSECTIONS}
#   SetShellVarContext current

#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\$(TermWinContacts).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinContacts} $1
   SectionSetInstTypes ${DelWinContacts} ${ALLSECTIONS}
#   SetShellVarContext current
!endif ;VISPA
   
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\MSN.lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelMSNLnk} $1
   SectionSetInstTypes ${DelMSNLnk} ${ALLSECTIONS}
#   SetShellVarContext current

!ifndef VISPA
#   SetShellVarContext all
   IfFileExists "$SMPROGRAMS\Windows Messenger.lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelMessengerLnk} $1
   SectionSetInstTypes ${DelMessengerLnk} ${ALLSECTIONS}
#   SetShellVarContext current
!endif ;VISPA

#   SetShellVarContext all
   IfFileExists "$STARTMENU\$(TermWinUpdate).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinUpdate} $1
   SectionSetInstTypes ${DelWinUpdate} ${ALLSECTIONS}
#   SetShellVarContext current

!ifdef VISPA
#   SetShellVarContext all
   IfFileExists "$STARTMENU\$(TermWelcomeCenter).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWelcomeCenter} $1
   SectionSetInstTypes ${DelWelcomeCenter} ${ALLSECTIONS}
#   SetShellVarContext current

#   SetShellVarContext all
   IfFileExists "$STARTMENU\$(TermWinMediaCenter).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinMediaCenter} $1
   SectionSetInstTypes ${DelWinMediaCenter} ${ALLSECTIONS}
#   SetShellVarContext current

#   SetShellVarContext all
   IfFileExists "$STARTMENU\$(TermWinUltExtras).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinUltExtras} $1
   SectionSetInstTypes ${DelWinUltExtras} ${ALLSECTIONS}
   SetShellVarContext current

   IfFileExists "$STARTMENU\$(TermWinMeetSpace).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinMeetSpace} $1
   SectionSetInstTypes ${DelWinMeetSpace} ${ALLSECTIONS}
!endif ;VISPA

!ifndef VISPA
   SetShellVarContext all
   IfFileExists "$STARTMENU\$(TermWinCat).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelWinCatalog} $1
   SectionSetInstTypes ${DelWinCatalog} ${ALLSECTIONS}
#   SetShellVarContext current

#   SetShellVarContext all
   IfFileExists "$STARTMENU\$(TermProgAccess).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelProgAccess} $1
   SectionSetInstTypes ${DelProgAccess} ${ALLSECTIONS}
#   SetShellVarContext current
!endif ;VISPA
   
#   SetShellVarContext all
   IfFileExists "$FAVORITES\$(TermLinks)" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelMsBookmarks} $1
   SectionSetInstTypes ${DelMsBookmarks} ${ALLSECTIONS}
   SetShellVarContext current
   
   IfFileExists "$PICTURES\$(TermSamplePics).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelSamplePictures} $1
   SectionSetInstTypes ${DelSamplePictures} ${ALLSECTIONS}

   IfFileExists "$MUSIC\$(TermSampleMusic).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelSampleMusic} $1
   SectionSetInstTypes ${DelSampleMusic} ${ALLSECTIONS}

!ifdef VISPA
   IfFileExists "$Videos\$(TermSampleVideos).lnk" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelSampleVideos} $1
   SectionSetInstTypes ${DelSampleVideos} ${ALLSECTIONS}
!endif ;VISPA

   SetShellVarContext all
   IfFileExists "$MUSIC\$(TermSamplePlaylists)\*.*" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelSamplePlaylists} $1
   SectionSetInstTypes ${DelSamplePlaylists} ${ALLSECTIONS}
   SetShellVarContext current

   IfFileExists "$WINDIR\*.bmp" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelBitmaps} $1
   SectionSetInstTypes ${DelBitmaps} ${ALLSECTIONS}

   IfFileExists "$WINDIR\Prefetch\*.pf" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelPrefetch} $1
   SectionSetInstTypes ${DelPrefetch} ${ALLSECTIONS}
   
!ifdef VISPA
   FindFirst $0 $1 "$WINDIR\SoftwareDistribution\Download\*.*"
   IfFileExists "$WINDIR\SoftwareDistribution\Download\$1" +4
   IntOp $1 ${SF_SELECTED} | ${SF_RO}
   SectionSetFlags ${DelUpdCache} $1
   SectionSetInstTypes ${DelUpdCache} ${ALLSECTIONS}
 !endif ;VISPA
   
  ${EndIf}
 FunctionEnd
!endif ;MINIXPY

!ifndef MINIXPY
 Function IsIniEmpty
; checks if the .ini file is empty and deletes if empty
  StrCpy $EmptyINI "0"
  
  ${IsINIEmpty} "General" "CompressedFolders"
  ${IsINIEmpty} "General" "RegWizC"
  !ifndef VISPA
    ${IsINIEmpty} "General" "ErrorRep"
  !endif ;VISPA
  ${IsINIEmpty} "General" "LMHash"
  ${IsINIEmpty} "General" "WGA"
  ${IsINIEmpty} "General" "WSHEnable"
  ${IsINIEmpty} "General" "RemAssist1"
  !ifndef VISPA
    ${IsINIEmpty} "General" "RepInfect"
  !endif ;VISPA
  ${IsINIEmpty} "General" "MediaSense"
  ${IsINIEmpty} "General" "RegDone"
  ${IsINIEmpty} "General" "FastShutdn"
  ${IsINIEmpty} "General" "DelPagefile"
  !ifndef VISPA
    ${IsINIEmpty} "General" "DelMRU"
  !endif ;VISPA
  ${IsINIEmpty} "General" "LastUser"
  ${IsINIEmpty} "General" "DisableUAC"

  ${IsINIEmpty} "Services" "ErrorRep"
  ${IsINIEmpty} "Services" "AutoWinUpd"
  ${IsINIEmpty} "Services" "WinDefend"
  ${IsINIEmpty} "Services" "TimeSync"
  ${IsINIEmpty} "Services" "SchedTask"
  !ifndef VISPA
    ${IsINIEmpty} "Services" "Indexing"
    ${IsINIEmpty} "Services" "DCOM"
  !endif ;VISPA
  ${IsINIEmpty} "Services" "UPnP"
  ${IsINIEmpty} "Services" "UPnPDiscovery"
  !ifndef VISPA
    ${IsINIEmpty} "Services" "Messenger"
  !endif ;VISPA
  ${IsINIEmpty} "Services" "RPCLoc"
  ${IsINIEmpty} "Services" "RemReg"
  !ifndef VISPA
    ${IsINIEmpty} "Services" "IcfIcs"
  !else ;VISPA
    ${IsINIEmpty} "Services" "Firewall"
  !endif ;VISPA

  ${IsINIEmpty} "InternetExplorer" "AutoUpdates"
  ${IsINIEmpty} "InternetExplorer" "SchedUpd"
  ${IsINIEmpty} "InternetExplorer" "IntWinAuth"
  ${IsINIEmpty} "InternetExplorer" "MaxConnPS"
  ${IsINIEmpty} "InternetExplorer" "uplddrvinfo"
  ${IsINIEmpty} "InternetExplorer" "DelTempFiles"
  ${IsINIEmpty} "InternetExplorer" "Alexa"
  ${IsINIEmpty} "InternetExplorer" "ActiveX1200"
  ${IsINIEmpty} "InternetExplorer" "JavaScript1400"
  ${IsINIEmpty} "InternetExplorer" "SearchAsst"

  ${IsINIEmpty} "WindowsMediaPlayer" "AutoLicAcqu"
  !ifndef VISPA
    ${IsINIEmpty} "WindowsMediaPlayer" "UpgradeMsg"
  !endif ;VISPA
  ${IsINIEmpty} "WindowsMediaPlayer" "Library"
  ${IsINIEmpty} "WindowsMediaPlayer" "MetadataRet"
  ${IsINIEmpty} "WindowsMediaPlayer" "UsageTrack"
  !ifndef VISPA
    ${IsINIEmpty} "WindowsMediaPlayer" "AutoUpdates"
    ${IsINIEmpty} "WindowsMediaPlayer" "NoMRU"
  !endif ;VISPA
  ${IsINIEmpty} "WindowsMediaPlayer" "AutoCodecDownl"
  !ifndef VISPA
    ${IsINIEmpty} "WindowsMediaPlayer" "AllowDeinst"
    ${IsINIEmpty} "WindowsMessenger" "WMRemOE"
    ${IsINIEmpty} "WindowsMessenger" "Uninstall"
  !endif ;VISPA
  ${IsINIEmpty} "WindowsSearch" "Disable"
  !ifndef VISPA
    ${IsINIEmpty} "Usability" "BalloonTips"
  !endif ;VISPA
  ${IsINIEmpty} "Usability" "LowDiskspace"
  !ifndef VISPA
    ${IsINIEmpty} "Usability" "CmdHere"
  !endif ;VISPA
  ${IsINIEmpty} "Usability" "CmdCompl"
  ${IsINIEmpty} "Usability" "AutoRun"
  !ifndef VISPA
    ${IsINIEmpty} "Usability" "SearchAsst"
  !endif ;VISPA
  ${IsINIEmpty} "Usability" "TaskGroup"
  ${IsINIEmpty} "Usability" "ClassicStartMenu"
  ${IsINIEmpty} "Usability" "ClassicLogon"
  !ifndef VISPA
    ${IsINIEmpty} "Usability" "BarricadeRootFolder"
  !endif ;VISPA
  ${IsINIEmpty} "Usability" "HiddenFiles"
  ${IsINIEmpty} "Usability" "ShowFileExt"
  ${IsINIEmpty} "Usability" "WinTheme"
  
  StrCmp $EmptyINI "0" 0 +2
  Delete "$APPDATA\${LOWERCASE}.ini"
 FunctionEnd
!endif ;MINIXPY

Function GetName
; detects if $Input has valid extension (.xpy/.vispa)
  Exch $0 ; input string
  Push $1
  Push $2
  StrCpy $1 0
  loop:
    IntOp $1 $1 - 1
    StrCpy $2 $0 1 $1
    StrCmp $2 "" exit2
    StrCmp $2 "." exit1 ; replace "\" with "." if you want file extension
    Goto loop
  exit1:
    IntOp $1 $1 + 1
    StrCpy $0 $0 "" $1
  exit2:
    Pop $2
    Pop $1
    Exch $0
FunctionEnd

Function StrReplace
; replaces quotes of $Input file location
  Exch $0 ;this will replace wrong characters
  Exch
  Exch $1 ;needs to be replaced
  Exch
  Exch 2
  Exch $2 ;the orginal string
  Push $3 ;counter
  Push $4 ;temp character
  Push $5 ;temp string
  Push $6 ;length of string that need to be replaced
  Push $7 ;length of string that will replace
  Push $R0 ;tempstring
  Push $R1 ;tempstring
  Push $R2 ;tempstring
  StrCpy $3 "-1"
  StrCpy $5 ""
  StrLen $6 $1
  StrLen $7 $0
  Loop:
  IntOp $3 $3 + 1
  Loop_noinc:
  StrCpy $4 $2 $6 $3
  StrCmp $4 "" ExitLoop
  StrCmp $4 $1 Replace
  Goto Loop
  Replace:
  StrCpy $R0 $2 $3
  IntOp $R2 $3 + $6
  StrCpy $R1 $2 "" $R2
  StrCpy $2 $R0$0$R1
  IntOp $3 $3 + $7
  Goto Loop_noinc
  ExitLoop:
  StrCpy $0 $2
  Pop $R2
  Pop $R1
  Pop $R0
  Pop $7
  Pop $6
  Pop $5
  Pop $4
  Pop $3
  Pop $2
  Pop $1
  Exch $0
FunctionEnd


Function CreateGUID
; creates a GUID for search scope
  System::Call 'ole32::CoCreateGuid(g .s)'
FunctionEnd


Function ThemeChange
; changes the pushed windows .theme
  Exch $R0

  IfFileExists "$R0" 0 End
  ExecShell 'open' '$R0'
  FindWindow $0 '#32770' '' $HWNDPARENT
  StrCpy $3 0

  wait:
  IntOp $3 $3 + 1
  StrCmp $3 50 End
  Sleep 1000
  System::Call 'user32::GetForegroundWindow()i .r1'
  StrCmp $0 $1 wait

  System::Call 'user32::GetWindowModule${If}(i r1, t .r2, i ${NSIS_MAX_STRLEN})'
  ${GetFileName} '$2' $2
  StrCmp $2 'comctl32.dll' 0 wait

  HideWindow
  GetDlgItem $2 $1 1
  SendMessage $2 ${BM_CLICK} 0 0
  End:

  Pop $R0
FunctionEnd


Function IconRefresh
; refreshes explorer to display modified icons
  System::Call 'Shell32::SHChangeNotify(i ${SHCNE_ASSOCCHANGED}, i ${SHCNF_IDLIST}, i 0, i 0)'
FunctionEnd


Function SearchEngines
  Exch $0
  ${If} $0 == "A9 (a9.com)"
	StrCpy $SearchPage "http://a9.com"
	StrCpy $SearchBar $SearchPage
	StrCpy $SearchQuery "http://a9.com/{searchTerms}"
	StrCpy $SearchName "A9"
  ${ElseIf} $0 == "Altavista (altavista.com)"
	StrCpy $SearchPage "http://altavista.com"
  	StrCpy $SearchBar $SearchPage
	StrCpy $SearchQuery "http://www.altavista.com/web/results?q={searchTerms}"
	StrCpy $SearchName "Altavista"
  ${ElseIf} $0 == "Ask (ask.com)"
	StrCpy $SearchPage "http://ask.com"
	StrCpy $SearchBar $SearchPage
	StrCpy $SearchQuery "http://www.ask.com/web?q={searchTerms}"
	StrCpy $SearchName "Ask"
  ${ElseIf} $0 == "Baidu (baidu.com)"
	StrCpy $SearchPage "http://baidu.com"
	StrCpy $SearchBar "baidu.com"
	StrCpy $SearchQuery "http://www.baidu.com/s?wd={searchTerms}"
	StrCpy $SearchName "Baidu"
  ${ElseIf} $0 == "Bing (bing.com)"
	StrCpy $SearchPage "http://bing.com"
	StrCpy $SearchBar "bing.com"
	StrCpy $SearchQuery "http://www.bing.com/search?q={searchTerms}"
	StrCpy $SearchName "Bing"
  ${ElseIf} $0 == "Google (google.com)"
	StrCpy $SearchPage "http://google.com"
	StrCpy $SearchBar "http://google.com/ie"
	StrCpy $SearchQuery "http://www.google.com/search?q={searchTerms}"
	StrCpy $SearchName "Google"
  ${ElseIf} $0 == "Ixquick (ixquick.com)"
	StrCpy $SearchPage "http://ixquick.com"
	StrCpy $SearchBar $SearchPage
	StrCpy $SearchQuery "http://ixquick.com/do/metasearch.pl?query={searchTerms}"
	StrCpy $SearchName "Ixquick"
  ${ElseIf} $0 == "Metacrawler (search.wikia.com)"
	StrCpy $SearchPage "http://metacrawler.com"
	StrCpy $SearchBar $SearchPage
	StrCpy $SearchQuery "http://www.metacrawler.com/info.metac/search/web/{searchTerms}"
	StrCpy $SearchName "Metacrawler"
  ${ElseIf} $0 == "Yahoo! (yahoo.com)"
	StrCpy $SearchPage "http://yahoo.com"
	StrCpy $SearchBar $SearchPage
	StrCpy $SearchQuery "http://search.yahoo.com/search?p={searchTerms}"
	StrCpy $SearchName "Yahoo!"
  ${EndIf}
  Pop $0
FunctionEnd


Function ValidateInput
  Push $Input
  Push '"'
  Push ""
  Call StrReplace
  Pop $Input

  Push $Input
  Call GetName
  Pop $R0
  StrCmp $R0 "${LOWERCASE}" 0 InvalidInput
  
  ${If} ${FileExists} "$Input"
	;  Temporary Setting for backward-compatibility
	 ValidInput:
	  Push $Input
	  !ifndef MINIXPY
	    Call UnSelectUnSections
	  !endif ;MINIXPY
	  Call SelectSections
	  ${IfNot} $Input == ""
		   ReadIniStr $SearchEngineIni "$Input" "${LOWERCASE}" "Search"
		   Push $SearchEngineIni
		   Call SearchEngines  	   
	  ${EndIf}
	  ReadINIStr $0 $Input "${LOWERCASE}" "Review"
	  StrCmp $0 "1" +2
	  StrCpy $Passive "1"
  ${ElseIf} ${FileExists} "$EXEDIR\$Input"
	  StrCpy $Input "$EXEDIR\$Input"
	  Goto ValidInput
  ${Else}
	 InvalidInput:
	  MessageBox MB_OK|MB_ICONINFORMATION "$(MBNotFound)"
	  Quit
 ${EndIf}
FunctionEnd


Function StrCSpnReverse
 Exch $R0 ; string to check
 Exch
 Exch $R1 ; string of chars
 Push $R2 ; current char
 Push $R3 ; current char
 Push $R4 ; char loop
 Push $R5 ; char loop

  StrCpy $R4 -1

  NextCharCheck:
  StrCpy $R2 $R0 1 $R4
  IntOp $R4 $R4 - 1
   StrCmp $R2 "" StrOK

   StrCpy $R5 -1

   NextChar:
   StrCpy $R3 $R1 1 $R5
   IntOp $R5 $R5 - 1
    StrCmp $R3 "" +2
    StrCmp $R3 $R2 NextCharCheck NextChar
     StrCpy $R0 $R2
     Goto Done

 StrOK:
 StrCpy $R0 ""

 Done:

 Pop $R5
 Pop $R4
 Pop $R3
 Pop $R2
 Pop $R1
 Exch $R0
FunctionEnd